#include "StdAfx.h"
#include "ByteBuffer.h"

CByteBuffer::CByteBuffer()
	: m_pBuffer(NULL),
	m_dwLen(0)
{
}


CByteBuffer::~CByteBuffer()
{
	if (m_pBuffer != NULL)
	{
		delete [] m_pBuffer;
		m_dwLen = 0;
	}
}

	inline int HexValue(int ch)
	{
		return isdigit(ch)? ch - '0' : (ch | 0x20) - 'a' + 10;
	}

BOOL CByteBuffer::FillWithHexString(const CString& str)
{
	if (str.GetLength() == 0)
		return FALSE;

	if (m_pBuffer != NULL)
		delete [] m_pBuffer;

	m_dwLen = str.GetLength() >> 1;
	if (str.GetLength() %2 != 0)
		m_dwLen += 1;

	m_pBuffer = new BYTE[m_dwLen];

	for (int i = 0; i < str.GetLength() /2 ; i++)
	{
		m_pBuffer[i] = (HexValue(str[i * 2]) << 4) | HexValue(str[i * 2 + 1]);
	}

	if (str.GetLength() %2 != 0)
		m_pBuffer[m_dwLen - 1] = HexValue(str[str.GetLength() - 1]);

	return TRUE;
}