// ConCpuPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "ConCpuPanel.h"

#include "ByteBuffer.h"

// CConCpuPanel Ի

IMPLEMENT_DYNAMIC(CConCpuPanel, CPanelBase)

CConCpuPanel::CConCpuPanel(CONCPUTYPE iType, CWnd* pParent /*=NULL*/)
	: CPanelBase(CConCpuPanel::IDD, pParent), m_iType(iType)
{

}

CConCpuPanel::~CConCpuPanel()
{
}

void CConCpuPanel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CONCPU_COMMAND_BOX, m_CommandList);
}


BEGIN_MESSAGE_MAP(CConCpuPanel, CPanelBase)
	ON_BN_CLICKED(IDC_CONCPU_TRANSMIT, &CConCpuPanel::OnBnClickedConcpuTransmit)
	ON_WM_ENABLE()
END_MESSAGE_MAP()


// CConCpuPanel Ϣ


BOOL CConCpuPanel::OnInitDialog()
{
	CPanelBase::OnInitDialog();


	m_CommandList.AddString(_T("00 84 00 00 08"));
	m_CommandList.AddString(_T("A0 A4 00 00 02 3F 00"));
	m_CommandList.AddString(_T("00 A4 04 00 0E 31 50 41 59 2E 53 59 53 2E 44 44 46 30 31"));
	m_CommandList.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CConCpuPanel::OnBnClickedConcpuTransmit()
{
	CString strCommand;
	m_CommandList.GetWindowText(strCommand);
	strCommand.Remove(_T(' '));

	if (strCommand.GetLength()== 0)
	{
		CString strMsg;
		LoadString(IDS_NOT_INPUT, strMsg);
		AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);
		m_CommandList.SetFocus();
		return;
	}

	CByteBuffer SendBuff;
	SendBuff.FillWithHexString(strCommand);

	BYTE RecvBuff[1024];
	DWORD dwRecvLength = sizeof(RecvBuff);

	LONG lResult;
	if (m_iType == TYPE_A_CPU)
		lResult = F3_TypeACpuTransmit(g_hReader, SendBuff, SendBuff.GetLength(), RecvBuff, &dwRecvLength);
	else
		lResult = F3_TypeBCpuTransmit(g_hReader, SendBuff, SendBuff.GetLength(), RecvBuff, &dwRecvLength);

	CString strInfo;
	if (lResult == 0)
	{
		CString str;
		Bytes2HexString(RecvBuff, dwRecvLength, str);
		GetDlgItem(IDC_CONCPU_RESPONSE_BOX)->SetWindowText(str);  // IDC_CONCPU_COMMAND_BOX

		strInfo.Format(_T("R-APDU: %s"), str);

		BOOL fFound = FALSE;
		for (int i = 0; i < m_CommandList.GetCount() && !fFound; i++)
		{
			m_CommandList.GetLBText( i, str);
			str.Remove(_T(' '));

			if (strCommand == str)
				fFound = TRUE;
		}
		
		if (! fFound)
		{
			Bytes2HexString( SendBuff, SendBuff.GetLength(), strCommand, ' ');
			m_CommandList.AddString( strCommand );
		}
	}

	CButton *pBtn = GetButton(IDC_CONCPU_TRANSMIT);
	CString strCmdName;
	pBtn->GetWindowText(strCmdName);

	OutputResult(lResult, strCmdName, strInfo);
}


void CConCpuPanel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	GetDlgItem(IDC_CONCPU_TRANSMIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_CONCPU_COMMAND_BOX)->EnableWindow(bEnable);
}
