// ConnectDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "ConnectDlg.h"
#include "afxdialogex.h"

DWORD CConnectDlg::dwPort = 1;
DWORD CConnectDlg::dwBaudRate = 9600;
BYTE  CConnectDlg::bAddress = 0;


// CConnectDlg Ի

IMPLEMENT_DYNAMIC(CConnectDlg, CDialog)

CConnectDlg::CConnectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConnectDlg::IDD, pParent)
{

}

CConnectDlg::~CConnectDlg()
{
}

void CConnectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMPORTS, m_PortList);
	DDX_Control(pDX, IDC_SPEEDS, m_SpeedList);
	DDX_Control(pDX, IDC_AUTO_CONFIG, m_AutoConBtn);
	DDX_Control(pDX, IDC_ADDRESSES, m_AddressList);
}


BEGIN_MESSAGE_MAP(CConnectDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_COMPORTS, &CConnectDlg::OnCbnSelchangeComports)
	ON_CBN_SELCHANGE(IDC_SPEEDS, &CConnectDlg::OnCbnSelchangeSpeeds)
	ON_CBN_SELCHANGE(IDC_ADDRESSES, &CConnectDlg::OnCbnSelchangeAddresses)
	ON_BN_CLICKED(IDC_AUTO_CONFIG, &CConnectDlg::OnBnClickedAutoConfig)
	ON_BN_CLICKED(IDCANCEL, &CConnectDlg::OnBnClickedCancel)
END_MESSAGE_MAP()


// CConnectDlg Ϣ


BOOL CConnectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitPortList();
	InitBaudList();
	InitAddressList();

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CConnectDlg::OnCbnSelchangeComports()
{
	dwPort = m_PortList.GetItemData(m_PortList.GetCurSel());
}


void CConnectDlg::OnCbnSelchangeSpeeds()
{
	dwBaudRate = m_SpeedList.GetItemData(m_SpeedList.GetCurSel());
}


void CConnectDlg::OnCbnSelchangeAddresses()
{
	bAddress = (BYTE) m_AddressList.GetItemData(m_AddressList.GetCurSel());
}


void CConnectDlg::OnBnClickedAutoConfig()
{
	BOOL bEnable = ! m_AutoConBtn.GetCheck();

	m_PortList.EnableWindow(bEnable);
	m_SpeedList.EnableWindow(bEnable);
	m_AddressList.EnableWindow(bEnable);
}


void CConnectDlg::OnOK()
{
	LONG lResult = 0;
	CString strMsg;
	LoadString(IDS_DEV_NOT_RECOGNIZED, strMsg);

	dwPort = m_PortList.GetItemData(m_PortList.GetCurSel());
	if (dwPort>=0x100)//USBӿ
	{
		dwBaudRate = dwPort&0xff;
		dwPort = 0;	
	} else
		dwBaudRate = m_SpeedList.GetItemData(m_SpeedList.GetCurSel());

	if (m_AutoConBtn.GetCheck() )
	{
		BOOL bFound = FALSE;

		bAddress = (BYTE) m_AddressList.GetItemData(m_AddressList.GetCurSel());

		for (int i = 0; i < m_PortList.GetCount() && !bFound; i++)
		{
			dwPort = (DWORD) m_PortList.GetItemData(i);

			for (int j = 0; j < m_SpeedList.GetCount() && !bFound; j++)
			{
				dwBaudRate = (DWORD) m_SpeedList.GetItemData(j);

				lResult = F3_Connect(dwPort, dwBaudRate, bAddress, &g_hReader);
				if (lResult == 0)
				{
					bFound = TRUE;
				}
			}
		}

		if (! bFound)
		{
			
			AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);
			return;
		}
	}
	else
	{
		lResult = F3_Connect(dwPort, dwBaudRate, bAddress, &g_hReader);
		/*CString str;
		str.Format(_T("F3_Connect : %d"),lResult);
		MessageBox(str);*/
		if (lResult != 0)
		{
		
			GetResultMessage(lResult, strMsg);
			AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);

			return;
		}
	}

	CDialog::OnOK();
}


void	CConnectDlg::InitPortList()
{
	/*HANDLE hComm;
	BOOL fOK = FALSE;
	TCHAR szBuff[1024];
	int idx;
	int sel = 0;

	m_PortList.ResetContent();
	for (int i = 1; i < 256; i++)
	{
		fOK = FALSE;
		_stprintf_s(szBuff, _T("\\\\.\\COM%d"), i);
		hComm = CreateFile(szBuff, 
			GENERIC_READ | GENERIC_WRITE, 
			0, 
			NULL, 
			OPEN_EXISTING, 
			0,
			NULL);
		if (hComm == INVALID_HANDLE_VALUE)
		{
			if (GetLastError() != ERROR_FILE_NOT_FOUND)
			{
				fOK = TRUE;
			}
		}
		else
		{
			fOK = TRUE;
			CloseHandle(hComm);
		}

		if (fOK)
		{
			_stprintf_s(szBuff, _T("COM%d"), i);
			idx = m_PortList.AddString(szBuff);
			m_PortList.SetItemData(idx, i);

			if ( i == dwPort )
				sel = idx;
		}
	}

	if (m_PortList.GetCount() == 0)
		GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
	else
		m_PortList.SetCurSel(sel); */


	TCHAR szName[32];
	BOOL fExist;
	HANDLE hComm;
	int itemIndex;
	for (int i = 1; i <= 256; i++)
	{
		_stprintf_s(szName, _T("\\\\.\\COM%d"), i);

		fExist = FALSE;
		hComm =  CreateFile(szName, 
			GENERIC_READ | GENERIC_WRITE, 
			0, 
			NULL, 
			OPEN_EXISTING, 
			0,
			NULL);
		if (hComm == INVALID_HANDLE_VALUE)
		{
			if (GetLastError() != ERROR_FILE_NOT_FOUND)
				fExist = TRUE;
		}
		else
		{
			fExist = TRUE;
			CloseHandle(hComm);
		}

		if (fExist)
		{
			_stprintf_s(szName, _T("COM%d"), i);
			itemIndex = m_PortList.AddString(szName);
			m_PortList.SetItemData(itemIndex, i);
		}
	}

	if (m_PortList.GetCount() > 0) m_PortList.SetCurSel(0);


	SUSER_HIDPare *pUser_HIDList;
	unsigned char bhidcnt;
	pUser_HIDList = IFH_EnumHIDDevice(0x4143,0x5248,TRUE,&bhidcnt);
	int loop;

	for (loop = 0;loop<bhidcnt;loop++)
	{
		_stprintf_s(szName, _T("USB%d SN:%s"), loop,pUser_HIDList[loop].hid_SerialNumber);
		itemIndex = m_PortList.AddString(szName);
		m_PortList.SetItemData(itemIndex, loop|0x100);
	}


}


void	CConnectDlg::InitBaudList()
{
	DWORD dwSpeeds[] = {9600,19200,38400, 57600, 115200 };
	CString strText;
	int idx;
	int sel = 0;

	for (int i = 0; i < sizeof(dwSpeeds) / sizeof(DWORD); i++)
	{
		strText.Format(_T("%d"), dwSpeeds[i]);
		idx = m_SpeedList.AddString(strText);
		m_SpeedList.SetItemData(idx, dwSpeeds[i]);	

		if ( dwSpeeds[i] == dwBaudRate)
			sel = i;
	}

	m_SpeedList.SetCurSel(sel);
}


void	CConnectDlg::InitAddressList()
{
	CString strText;
	int idx;
	int sel = 0;

	for (int i = 0; i <= 15; i++)
	{
		strText.Format(_T("%d#"), i);
		idx = m_AddressList.AddString(strText);
		m_AddressList.SetItemData(idx, i);

		if ( i == bAddress)
			sel = i;
	}

	m_AddressList.SetCurSel(sel);
}

void CConnectDlg::OnBnClickedCancel()
{
	// TODO: ڴӿؼ֪ͨ
	CDialog::OnCancel();
}
