// CpuPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "CpuPanel.h"

#include "ByteBuffer.h"

// CCpuPanel Ի

IMPLEMENT_DYNAMIC(CCpuPanel, CPanelBase)

CCpuPanel::CCpuPanel(CWnd* pParent /*=NULL*/)
	: CPanelBase(CCpuPanel::IDD, pParent)
{

}

CCpuPanel::~CCpuPanel()
{
}

void CCpuPanel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ICC_COMMAND_BOX, m_CommandList);
}


BEGIN_MESSAGE_MAP(CCpuPanel, CPanelBase)
	ON_BN_CLICKED(IDC_ICC_EMV_WITH_5V, &CCpuPanel::OnBnClickedIccEmvWith5v)
	ON_BN_CLICKED(IDC_ICC_7816_WITH_5V, &CCpuPanel::OnBnClickedIcc7816With5v)
	ON_BN_CLICKED(IDC_ICC_7816_WITH_3V, &CCpuPanel::OnBnClickedIcc7816With3v)
	ON_BN_CLICKED(IDC_ICC_ACTIVATE, &CCpuPanel::OnBnClickedIccActivate)
	ON_BN_CLICKED(IDC_ICC_WARM_RESET, &CCpuPanel::OnBnClickedIccWarmReset)
	ON_BN_CLICKED(IDC_ICC_DEACTIVATE, &CCpuPanel::OnBnClickedIccDeactivate)
	ON_BN_CLICKED(IDC_ICC_STATUS, &CCpuPanel::OnBnClickedIccStatus)
	ON_BN_CLICKED(IDC_ICC_TRANSMIT, &CCpuPanel::OnBnClickedIccTransmit)
	ON_CBN_SELCHANGE(IDC_ICC_PROTOCOL_LIST, &CCpuPanel::OnCbnSelchangeIccProtocolList)
	ON_WM_ENABLE()
	ON_BN_CLICKED(IDC_PPS_T0, &CCpuPanel::OnBnClickedPpsT0)
	ON_BN_CLICKED(IDC_PPS_T1, &CCpuPanel::OnBnClickedPpsT1)
END_MESSAGE_MAP()



BOOL CCpuPanel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	CComboBox *pList = GetComboBox(IDC_ICC_PROTOCOL_LIST);
	int idx = pList->AddString(_T("T = 0"));
	pList->SetItemData(idx, ICC_PROTOCOL_T0); // m_protocol
	idx = pList->AddString(_T("T = 1"));
	pList->SetItemData(idx, ICC_PROTOCOL_T1);

	CString strTitle;
	LoadString(IDS_AUTO_SELECT, strTitle);
	idx = pList->AddString(strTitle);
	pList->SetItemData(idx, ICC_PROTOCOL_AUTO);
	pList->SetCurSel(0);
	m_bProtocol = ICC_PROTOCOL_T0;

	GetButton(IDC_ICC_EMV_WITH_5V)->SetCheck(TRUE);
	m_bMode = VCC_5V_EMV;

	m_CommandList.AddString(_T("00 84 00 00 08"));
	m_CommandList.AddString(_T("A0 A4 00 00 02 3F 00"));
	m_CommandList.AddString(_T("00 A4 04 00 0E 31 50 41 59 2E 53 59 53 2E 44 44 46 30 31"));
	m_CommandList.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

// CCpuPanel Ϣ

BOOL CCpuPanel::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN && 
		pMsg->wParam == VK_RETURN )
	{   
		CWnd *pWnd = GetFocus();
		if (pWnd->GetDlgCtrlID() == IDC_ICC_COMMAND_BOX)
		{
			OnBnClickedIccTransmit();
			pWnd->SetFocus();
			return TRUE;
		}
	}

	return CPanelBase::PreTranslateMessage(pMsg);
}


void CCpuPanel::OnBnClickedIccEmvWith5v()
{
	m_bMode = VCC_5V_EMV;
}


void CCpuPanel::OnBnClickedIcc7816With5v()
{
	m_bMode = VCC_5V_ISO7816;
}


void CCpuPanel::OnBnClickedIcc7816With3v()
{
	m_bMode = VCC_3V_ISO7816;
}


void CCpuPanel::OnBnClickedIccActivate()
{
	CpuReset(TRUE);
}


void CCpuPanel::OnBnClickedIccWarmReset()
{
	CpuReset(FALSE);
}


void CCpuPanel::OnBnClickedIccDeactivate()
{
	LONG lResult = F3_CpuDeactivate(g_hReader);
	OutputResult(lResult, GetFocus(), NULL);
}


void CCpuPanel::OnBnClickedIccStatus()
{
	BYTE bStatus;

	LONG lResult =F3_CpuGetStatus(g_hReader, &bStatus);

	CString strMsg;
	if (lResult == 0)
	{
		switch (bStatus)
		{
		case STATUS_DEACTIVATION:
			LoadString(IDS_UNACTIVATED, strMsg);
			break;
		case STATUS_CLKFREQ_3_57:
			LoadString(IDS_CLKFREQ_3_57, strMsg);
			break;
		case STATUS_CLKFREQ_7_16:
			LoadString(IDS_CLKFREQ_7_16, strMsg);
			break;
		}
	}

	OutputResult(lResult, GetFocus(), strMsg);
}


void CCpuPanel::OnBnClickedIccTransmit()
{
	CString strCommand;
	m_CommandList.GetWindowText(strCommand);
	strCommand.Remove(_T(' '));

	if (strCommand.GetLength()== 0)
	{
		CString strMsg;
		LoadString(IDS_NOT_INPUT, strMsg);
		AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);
		m_CommandList.SetFocus();
		return;
	}

	CByteBuffer SendBuff;
	SendBuff.FillWithHexString(strCommand);

	BYTE RecvBuff[1024];
	DWORD dwRecvLength = sizeof(RecvBuff);

	LONG lResult= F3_CpuTransmit(g_hReader,m_bProtocol, SendBuff, (USHORT) SendBuff.GetLength(), RecvBuff, &dwRecvLength);

	CString strInfo;
	if (lResult == 0)
	{
		CString str;
		Bytes2HexString(RecvBuff, dwRecvLength, str);
		GetDlgItem(IDC_ICC_RESPONSE_BOX)->SetWindowText(str);

		strInfo.Format(_T("R-APDU: %s"), str);

		BOOL fFound = FALSE;
		for (int i = 0; i < m_CommandList.GetCount() && !fFound; i++)
		{
			m_CommandList.GetLBText( i, str);
			str.Remove(_T(' '));

			if (strCommand == str)
				fFound = TRUE;
		}
		
		if (! fFound)
		{
			Bytes2HexString( SendBuff, SendBuff.GetLength(), strCommand, ' ');
			m_CommandList.AddString( strCommand );
		}
	}

	CButton *pBtn = GetButton(IDC_ICC_TRANSMIT);  //IDC_ICC_TRANSMIT
	CString strCmdName;
	pBtn->GetWindowText(strCmdName);

	OutputResult(lResult, strCmdName, strInfo);
}


void CCpuPanel::OnCbnSelchangeIccProtocolList()
{
	CComboBox *pList = GetComboBox(IDC_ICC_PROTOCOL_LIST);  //IDC_ICC_PROTOCOL_LIST
	m_bProtocol = (BYTE) pList->GetItemData(pList->GetCurSel());
}


void CCpuPanel::CpuReset(BOOL bCold)
{
	BYTE ATRBuff[32];
	DWORD ATRLength = sizeof(ATRBuff);
	CString strInfo;
	LONG lResult;

	if (bCold)
		lResult = F3_CpuActivate(g_hReader, &m_bProtocol, ATRBuff, &ATRLength, m_bMode);
	else
		lResult = F3_CpuWarmReset(g_hReader, &m_bProtocol, ATRBuff, &ATRLength);

	if (lResult == 0)
	{
		CString strATR;
		Bytes2HexString(ATRBuff, ATRLength, strATR);
		SetDlgItemText(IDC_ICC_ATR_BOX, strATR);

		CComboBox *pList = GetComboBox(IDC_ICC_PROTOCOL_LIST);
		CString s1;
		switch ( m_bProtocol )
		{
		case ICC_PROTOCOL_T0:
			s1 = _T("T = 0");
			pList->SetCurSel(0);
			break;
		case ICC_PROTOCOL_T1:
			s1 = _T("T = 1");
			pList->SetCurSel(1);
			break;
		}

		strInfo.Format(_T("Protocol: %s, ATR: %s"),s1, strATR);
	}

	OutputResult(lResult, GetFocus(), strInfo);
}


void CCpuPanel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	GetDlgItem(IDC_ICC_EMV_WITH_5V)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_7816_WITH_5V)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_7816_WITH_3V)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_ACTIVATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_WARM_RESET)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_DEACTIVATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_STATUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_TRANSMIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_PROTOCOL_LIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_ICC_COMMAND_BOX)->EnableWindow(bEnable);

	GetDlgItem(IDC_PPS_T0)->EnableWindow(bEnable);
	GetDlgItem(IDC_PPS_T1)->EnableWindow(bEnable);
}


void CCpuPanel::OnBnClickedPpsT0()
{
	LONG lRet = F3_CpuPPSExchange(g_hReader, ICC_PROTOCOL_T0);
	OutputResult(lRet, GetFocus(), NULL);
}


void CCpuPanel::OnBnClickedPpsT1()
{
	LONG lRet = F3_CpuPPSExchange(g_hReader, ICC_PROTOCOL_T1);
	OutputResult(lRet, GetFocus(), NULL);
}
