// PcscPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "PcscPanel.h"
#include "afxdialogex.h"
#include "ByteBuffer.h"

#define WM_BEGINCONNECT	(WM_USER + 10)
#define WM_PCSCDISCONNECT	(WM_USER + 11)


// CPcscPanel Ի

IMPLEMENT_DYNAMIC(CPcscPanel, CPanelBase)

CPcscPanel::CPcscPanel(CWnd* pParent /*=NULL*/)
	: CPanelBase(CPcscPanel::IDD, pParent)
{

}

CPcscPanel::~CPcscPanel()
{
}

void CPcscPanel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PCSC_READER_LIST, m_ReaderList);
	DDX_Control(pDX, IDC_PCSC_CONN_MODE_LIST, m_ShareModeList);
	DDX_Control(pDX, IDC_PCSC_PROTO_LIST, m_PreferredProtocolList);
	DDX_Control(pDX, IDC_PCSC_COMMAND_BOX, m_CommandList);
}


BEGIN_MESSAGE_MAP(CPcscPanel, CPanelBase)
	ON_BN_CLICKED(IDC_PCSC_REFRESH, &CPcscPanel::OnBnClickedPcscRefresh)
	ON_WM_ENABLE()
	ON_BN_CLICKED(IDC_PCSC_CONNECT, &CPcscPanel::OnBnClickedPcscConnect)
	ON_BN_CLICKED(IDC_PCSC_DISCONNECT, &CPcscPanel::OnBnClickedPcscDisconnect)
	ON_BN_CLICKED(IDC_PCSC_TRANSMIT, &CPcscPanel::OnBnClickedPcscTransmit)

	ON_MESSAGE(WM_BEGINCONNECT, &CPcscPanel::BeginPcscConnect)
	ON_MESSAGE(WM_PCSCDISCONNECT, &CPcscPanel::OnPcscDisconnect)
END_MESSAGE_MAP()


// CPcscPanel Ϣ

BOOL CPcscPanel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	m_CommandList.AddString(_T("00 84 00 00 08"));
	m_CommandList.AddString(_T("A0 A4 00 00 02 3F 00"));
	m_CommandList.AddString(_T("00 A4 04 00 0E 31 50 41 59 2E 53 59 53 2E 44 44 46 30 31"));
	m_CommandList.SetCurSel(0);

	CString strTitle;
	int index;

	index = m_ShareModeList.AddString( _T("Shared"));
	m_ShareModeList.SetItemData(index, SCARD_SHARE_SHARED );
	index = m_ShareModeList.AddString( _T("Exclusive"));
	m_ShareModeList.SetItemData(index, SCARD_SHARE_EXCLUSIVE );
	index = m_ShareModeList.AddString( _T("Direct"));
	m_ShareModeList.SetItemData(index, SCARD_SHARE_DIRECT );
	m_ShareModeList.SetCurSel(0);

	index = m_PreferredProtocolList.AddString( _T("T = 0") );
	m_PreferredProtocolList.SetItemData( index, SCARD_PROTOCOL_T0 );
	index = m_PreferredProtocolList.AddString( _T("T = 1") );
	m_PreferredProtocolList.SetItemData( index, SCARD_PROTOCOL_T1 );
	index = m_PreferredProtocolList.AddString( _T("Optimal") );
	m_PreferredProtocolList.SetItemData( index, SCARD_PROTOCOL_OPTIMAL );
	m_PreferredProtocolList.SetCurSel(0);

	EnableUI( FALSE );


	m_pThread = AfxBeginThread(&PCSCAutoConnectProc,
		this, THREAD_PRIORITY_NORMAL, CREATE_SUSPENDED, NULL);
	if (m_pThread != NULL)
	{
		m_pThread->m_bAutoDelete = FALSE;
		m_hStopEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
		m_pThread->ResumeThread();
	}
	else
	{
		AfxMessageBox(_T("Fail to Create Thread!"), MB_OK | MB_ICONERROR);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CPcscPanel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	
}


void CPcscPanel::OnBnClickedPcscRefresh()
{
	ListReaders();
}



void CPcscPanel::OnBnClickedPcscConnect()
{
	CString strReaderName;
	m_ReaderList.GetLBText(m_ReaderList.GetCurSel(), strReaderName);

	DWORD dwShareMode = m_ShareModeList.GetItemData( m_ShareModeList.GetCurSel());
	DWORD dwPerferredProcotol = m_PreferredProtocolList.GetItemData( m_PreferredProtocolList.GetCurSel() );

	CString strMsg;
	CString strATR;
	LONG lResult = 0;

	if (m_hContext == NULL)
	{
		lResult = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &m_hContext);
		if (lResult != 0)
			goto OR_ERROR;
	}

	lResult = SCardConnect(m_hContext, 
		strReaderName, 
		dwShareMode, 
		dwPerferredProcotol, //SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1 | SCARD_PROTOCOL_OPTIMAL,
		&m_hCard, 
		&m_dwProtocol);
	if (lResult != 0)
		goto OR_ERROR;

	BYTE ATRBuff[128];
	DWORD ATRLength = sizeof(ATRBuff);

	lResult = SCardStatus(m_hCard, NULL, NULL, NULL, NULL, ATRBuff, &ATRLength);
	if ( lResult != 0 )
		goto OR_ERROR;

	Bytes2HexString( ATRBuff, ATRLength, strATR );
	SetDlgItemText( IDC_PCSC_ATR_BOX, strATR );

	EnableUI( TRUE );

	return;

OR_ERROR:
	GetResultMessage2(lResult, strMsg);
	AfxMessageBox( strMsg, MB_OK | MB_ICONERROR );
}


void CPcscPanel::OnBnClickedPcscDisconnect()
{
	LONG lResult = SCardDisconnect(m_hCard, SCARD_EJECT_CARD);
	if (lResult != 0)
	{
		CString strMsg;
		GetResultMessage2(lResult, strMsg);
		AfxMessageBox( strMsg, MB_OK | MB_ICONERROR );
	}
	else
		EnableUI( FALSE );
}


void CPcscPanel::OnBnClickedPcscTransmit()
{
	CString strCommand;
	m_CommandList.GetWindowText(strCommand);
	strCommand.Remove(_T(' '));

	if (strCommand.GetLength()== 0)
	{
		CString strMsg;
		LoadString(IDS_NOT_INPUT, strMsg);
		AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);
		m_CommandList.SetFocus();
		return;
	}

	CByteBuffer SendBuff;
	SendBuff.FillWithHexString(strCommand);

	BYTE RecvBuff[1024];
	DWORD RecvLength = sizeof(RecvBuff);

	SCARD_IO_REQUEST IO_Request;
	IO_Request.dwProtocol = m_dwProtocol;
	IO_Request.cbPciLength = (DWORD) sizeof(SCARD_IO_REQUEST);

	CString strMsg;
	LONG lResult = SCardTransmit(m_hCard, &IO_Request, SendBuff, SendBuff.GetLength(), NULL, RecvBuff, &RecvLength);

	if (lResult == 0)
	{
		CString str;
		Bytes2HexString(RecvBuff,  RecvLength, str, ' ');
		SetDlgItemText( IDC_PCSC_RESPONSE_BOX, str );

		strMsg.Format(_T("R-APDU: %s\r\n\r\n"), str);
		OutputMessage(strMsg);

		BOOL fFound = FALSE;
		for (int i = 0; i < m_CommandList.GetCount() && !fFound; i++)
		{
			m_CommandList.GetLBText( i, str);
			str.Remove(_T(' '));

			if (strCommand == str)
				fFound = TRUE;
		}
		
		if (! fFound)
		{
			Bytes2HexString( SendBuff, SendBuff.GetLength(), strCommand, ' ');
			m_CommandList.AddString( strCommand );
		}
	}
	else
	{
		GetResultMessage2(lResult, strMsg);
		AfxMessageBox( strMsg, MB_OK | MB_ICONERROR );
	}
}


BOOL CPcscPanel::ListReaders()
{
	//TCHAR mszReaders[1024];
	//DWORD dwLen = sizeof(mszReaders) / sizeof(TCHAR);
	//LONG lResult = 0;

	//m_ReaderList.ResetContent();
	//GetDlgItem(IDC_PCSC_CONNECT)->EnableWindow(FALSE);

	//if (m_hContext == NULL)
	//{
	//	lResult = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &m_hContext);
	//	if (lResult != 0)
	//		return lResult;
	//}

	//lResult =  SCardListReaders(m_hContext, NULL, mszReaders, &dwLen);

	//if (lResult != 0)
	//{
	//	//CString strMsg;
	//	//GetResultMessage2(lResult, strMsg);
	//	//AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);
	//	return FALSE;
	//}
	//else
	//{
	//	PCTSTR pszReaderName;
	//	DWORD dwNameLen = 0;
	//	while (TRUE)
	//	{
	//		pszReaderName = &mszReaders[dwNameLen];
	//		m_ReaderList.AddString(pszReaderName);

	//		dwNameLen += _tcslen(pszReaderName) + 1;
	//		if (dwNameLen >= dwLen - 2)
	//			break;
	//	}

	//	if ( m_ReaderList.GetCount() > 0)
	//	{
	//		GetDlgItem(IDC_PCSC_CONNECT)->EnableWindow(TRUE);
	//		m_ReaderList.SetCurSel(0);
	//		return TRUE;
	//	}
	//}

	//return FALSE;


	TCHAR mszReaders[1024];
	DWORD dwLen = sizeof(mszReaders) / sizeof(TCHAR);
	LONG lResult = 0;

	m_ReaderList.ResetContent();
	GetDlgItem(IDC_PCSC_CONNECT)->EnableWindow(FALSE);

	if (m_hContext == NULL)
	{
		lResult = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &m_hContext);
		if (lResult != 0)
			return lResult;
	}

	lResult =  SCardListReaders(m_hContext, NULL, mszReaders, &dwLen);

	if (lResult != 0)
	{
		//CString strMsg;
		//GetResultMessage2(lResult, strMsg);
		//AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else
	{
		PCTSTR pszReaderName;
		DWORD dwNameLen = 0;
		while (TRUE)
		{
			pszReaderName = &mszReaders[dwNameLen];
			m_ReaderList.AddString(pszReaderName);

			dwNameLen += _tcslen(pszReaderName) + 1;
			if (dwNameLen >= dwLen - 2)
				break;
		}

		if ( m_ReaderList.GetCount() > 0)
		{
			GetDlgItem(IDC_PCSC_CONNECT)->EnableWindow(TRUE);
			m_ReaderList.SetCurSel(0);
			return TRUE;
		}
	}

	return FALSE;
}


UINT CPcscPanel::PCSCAutoConnectProc(LPVOID pvParam)
{
	CPcscPanel* pDlg = (CPcscPanel*) pvParam;
	LONG lResult = 0;
	CRSTATUS crs;

	while (true)
	{
		if (WaitForSingleObject(pDlg->m_hStopEvent, 100) == WAIT_OBJECT_0)
			break;

		if (! pDlg->m_pcscConnected )
		{
			::PostMessage(pDlg->GetSafeHwnd(), WM_BEGINCONNECT, NULL, NULL);
			Sleep(500);
		}
		else
		{
			lResult = SCardStatus(pDlg->m_hCard, NULL, NULL, NULL, NULL, NULL, NULL);
			if ( lResult != 0 )
			{
				SCardDisconnect(pDlg->m_hCard, SCARD_EJECT_CARD);
				pDlg->m_pcscConnected = FALSE;
				::PostMessage(pDlg->GetSafeHwnd(), WM_PCSCDISCONNECT, NULL, NULL);
			}
		}
	}

	return 0;
}


LRESULT CPcscPanel::BeginPcscConnect(WPARAM wParam, LPARAM lParam)
{
	//if ( m_pcscConnected )
	//	return 0;

	//ListReaders();
	//if ( m_ReaderList.GetCount() == 0)
	//	return 0;

	//CString strReaderName;
	//m_ReaderList.GetLBText(m_ReaderList.GetCurSel(), strReaderName);

	//DWORD dwShareMode = m_ShareModeList.GetItemData( m_ShareModeList.GetCurSel());
	//DWORD dwPerferredProcotol = m_PreferredProtocolList.GetItemData( m_PreferredProtocolList.GetCurSel() );

	//CString strMsg;
	//CString strATR;
	//LONG lResult = 0;

	//if (m_hContext == NULL)
	//{
	//	lResult = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &m_hContext);
	//	if (lResult != 0)
	//		return 0;
	//}

	//lResult = SCardConnect(m_hContext, 
	//	strReaderName, 
	//	dwShareMode, 
	//	dwPerferredProcotol, //SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1 | SCARD_PROTOCOL_OPTIMAL,
	//	&m_hCard, 
	//	&m_dwProtocol);
	//if (lResult != 0)
	//	return 0;

	//BYTE ATRBuff[128];
	//DWORD ATRLength = sizeof(ATRBuff);

	//lResult = SCardStatus(m_hCard, NULL, NULL, NULL, NULL, ATRBuff, &ATRLength);
	//if ( lResult != 0 )
	//	return 0;

	//Bytes2HexString( ATRBuff, ATRLength, strATR );
	//SetDlgItemText( IDC_PCSC_ATR_BOX, strATR );

	//strMsg.Format(_T("ATR: %s\r\n"), strATR);
	//OutputMessage(strMsg);

	//EnableUI( TRUE );

	//m_pcscConnected = TRUE;

	//return 0;


	
	if ( m_pcscConnected )
		return 0;

	
	if ( m_ReaderList.GetCount() == 0)
	{
		ListReaders();
	}

	if ( m_ReaderList.GetCount() == 0 )
		return 0;

	CString strReaderName;
	m_ReaderList.GetLBText(m_ReaderList.GetCurSel(), strReaderName);

	DWORD dwShareMode = m_ShareModeList.GetItemData( m_ShareModeList.GetCurSel());
	DWORD dwPerferredProcotol = m_PreferredProtocolList.GetItemData( m_PreferredProtocolList.GetCurSel() );

	CString strMsg;
	CString strATR;
	LONG lResult = 0;

	if (m_hContext == NULL)
	{
		lResult = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &m_hContext);
		if (lResult != 0)
			return 0;
	}

	lResult = SCardConnect(m_hContext, 
		strReaderName, 
		dwShareMode, 
		dwPerferredProcotol, //SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1 | SCARD_PROTOCOL_OPTIMAL,
		&m_hCard, 
		&m_dwProtocol);
	if (lResult != 0)
		return 0;

	BYTE ATRBuff[128];
	DWORD ATRLength = sizeof(ATRBuff);

	lResult = SCardStatus(m_hCard, NULL, NULL, NULL, NULL, ATRBuff, &ATRLength);
	if ( lResult != 0 )
		return 0;

	Bytes2HexString( ATRBuff, ATRLength, strATR );
	SetDlgItemText( IDC_PCSC_ATR_BOX, strATR );

	strMsg.Format(_T("ATR: %s\r\n"), strATR);
	OutputMessage(strMsg);

	EnableUI( TRUE );

	m_pcscConnected = TRUE;

	return 0;
}

LRESULT CPcscPanel::OnPcscDisconnect(WPARAM wParam, LPARAM lParam)
{
	EnableUI(FALSE);

	return 0;
}


void	CPcscPanel::EnableUI(BOOL bConnected)
{
	GetDlgItem(IDC_PCSC_REFRESH)->EnableWindow( FALSE );
	GetDlgItem(IDC_PCSC_CONNECT)->EnableWindow( FALSE );
	GetDlgItem(IDC_PCSC_DISCONNECT)->EnableWindow( FALSE);
	GetDlgItem(IDC_PCSC_TRANSMIT)->EnableWindow( bConnected);

	m_ReaderList.EnableWindow( !bConnected);
	m_ShareModeList.EnableWindow( !bConnected);
	m_PreferredProtocolList.EnableWindow( !bConnected);
	m_CommandList.EnableWindow( bConnected);
}