// SamPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "SamPanel.h"
#include "ByteBuffer.h"


// CSamPanel Ի

IMPLEMENT_DYNAMIC(CSamPanel, CPanelBase)

CSamPanel::CSamPanel(CWnd* pParent /*=NULL*/)
	: CPanelBase(CSamPanel::IDD, pParent)
{

}

CSamPanel::~CSamPanel()
{
}

void CSamPanel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SAM_COMMAND_BOX, m_CommandList);
}


BEGIN_MESSAGE_MAP(CSamPanel, CPanelBase)
	ON_WM_ENABLE()
	ON_BN_CLICKED(IDC_SAM_EMV_WITH_5V, &CSamPanel::OnBnClickedSamEmvWith5v)
	ON_BN_CLICKED(IDC_SAM_7816_WITH_5V, &CSamPanel::OnBnClickedSam7816With5v)
	ON_BN_CLICKED(IDC_SAM_7816_WITH_3V, &CSamPanel::OnBnClickedSam7816With3v)
	ON_BN_CLICKED(IDC_SAM_ACTIVATE, &CSamPanel::OnBnClickedSamActivate)
	ON_BN_CLICKED(IDC_SAM_WARM_RESET, &CSamPanel::OnBnClickedSamWarmReset)
	ON_BN_CLICKED(IDC_SAM_DEACTIVATE, &CSamPanel::OnBnClickedSamDeactivate)
	ON_BN_CLICKED(IDC_SAM_STATUS, &CSamPanel::OnBnClickedSamStatus)
	ON_CBN_SELCHANGE(IDC_SAM_LIST, &CSamPanel::OnCbnSelchangeSamList)
	ON_CBN_SELCHANGE(IDC_SAM_PROTOCOL_LIST, &CSamPanel::OnCbnSelchangeSamProtocolList)
	ON_BN_CLICKED(IDC_SAM_TRANSMIT, &CSamPanel::OnBnClickedSamTransmit)
	ON_BN_CLICKED(IDC_SAM_SELECT, &CSamPanel::OnBnClickedSamSelect)
END_MESSAGE_MAP()


// CSamPanel Ϣ


BOOL CSamPanel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	CString str;

	CComboBox *pList = GetComboBox(IDC_SAM_PROTOCOL_LIST);
	int idx = pList->AddString(_T("T = 0"));
	pList->SetItemData(idx, ICC_PROTOCOL_T0);
	idx = pList->AddString(_T("T = 1"));
	pList->SetItemData(idx, ICC_PROTOCOL_T1);

		CString strTitle;
	LoadString(IDS_AUTO_SELECT, strTitle);
	idx = pList->AddString(strTitle);
	pList->SetItemData(idx, ICC_PROTOCOL_AUTO);
	pList->SetCurSel(0);
	m_bProtocol = ICC_PROTOCOL_T0;

	pList = GetComboBox(IDC_SAM_LIST);
	for (int i = 0; i < 5; i++)
	{
		str.Format(_T("SAM%d"), i+1);
		idx = pList->AddString(str);
		pList->SetItemData(idx,  i + 1);
	}
	pList->SetCurSel(0);
	m_bSAMNumber = 1;

	GetButton(IDC_SAM_EMV_WITH_5V)->SetCheck(TRUE);
	m_bMode = VCC_5V_EMV;

	m_CommandList.AddString(_T("00 84 00 00 08"));
	m_CommandList.AddString(_T("A0 A4 00 00 02 3F 00"));
	m_CommandList.AddString(_T("00 A4 04 00 0E 31 50 41 59 2E 53 59 53 2E 44 44 46 30 31"));
	m_CommandList.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}



BOOL CSamPanel::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN && 
		pMsg->wParam == VK_RETURN )
	{   
		CWnd *pWnd = GetFocus();
		if (pWnd->GetDlgCtrlID() == IDC_SAM_COMMAND_BOX)
		{
			OnBnClickedSamTransmit();
			pWnd->SetFocus();
			return TRUE;
		}
	}

	return CPanelBase::PreTranslateMessage(pMsg);
}

void CSamPanel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	GetDlgItem(IDC_SAM_EMV_WITH_5V)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_7816_WITH_5V)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_7816_WITH_3V)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_ACTIVATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_WARM_RESET)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_DEACTIVATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_STATUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_LIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_PROTOCOL_LIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_TRANSMIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_SELECT)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAM_COMMAND_BOX)->EnableWindow(bEnable);
}


void CSamPanel::OnBnClickedSamEmvWith5v()
{
	m_bMode = VCC_5V_EMV;
}


void CSamPanel::OnBnClickedSam7816With5v()
{
	m_bMode = VCC_5V_ISO7816;
}


void CSamPanel::OnBnClickedSam7816With3v()
{
	m_bMode = VCC_3V_ISO7816;
}


void CSamPanel::OnBnClickedSamActivate()
{
	SamReset(TRUE);
}


void CSamPanel::OnBnClickedSamWarmReset()
{
	SamReset(FALSE);
}


void CSamPanel::OnBnClickedSamDeactivate()
{
	LONG lResult = F3_SamDeactivate(g_hReader);
	OutputResult(lResult, GetFocus(), NULL);
}


void CSamPanel::OnBnClickedSamStatus()
{
	BYTE bStatus;

	LONG lResult = F3_SamGetStatus(g_hReader, &bStatus, &m_bSAMNumber);

	CString strMsg;
	if (lResult == 0)
	{
		CString s1, s2;
		switch (bStatus)
		{
		case STATUS_DEACTIVATION:
			LoadString(IDS_UNACTIVATED, s1);
			break;
		case STATUS_CLKFREQ_3_57:
			LoadString(IDS_CLKFREQ_3_57, s1);
			break;
		case STATUS_CLKFREQ_7_16:
			LoadString(IDS_CLKFREQ_7_16, s1);
			break;
		}

		LoadString(IDS_SAM_NUMBER, s2);
		strMsg.Format(_T("%s, %s: %d"), s1, s2, m_bSAMNumber);

		CComboBox *pList = GetComboBox(IDC_SAM_LIST);
		pList->SetCurSel(m_bSAMNumber - 1);
	}

	OutputResult(lResult, GetFocus(), strMsg);
}


void CSamPanel::OnCbnSelchangeSamList()
{
	CComboBox *pList = GetComboBox(IDC_SAM_LIST);
	m_bSAMNumber = pList->GetItemData(pList->GetCurSel());
}


void CSamPanel::OnCbnSelchangeSamProtocolList()
{
	CComboBox *pList = GetComboBox(IDC_SAM_PROTOCOL_LIST);
	m_bProtocol = (BYTE) pList->GetItemData(pList->GetCurSel());
}


void CSamPanel::OnBnClickedSamTransmit()
{
	CString strCommand;
	m_CommandList.GetWindowText(strCommand);
	strCommand.Remove(_T(' '));

	if (strCommand.GetLength()== 0)
	{
		CString strMsg;
		LoadString(IDS_NOT_INPUT, strMsg);
		AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);
		m_CommandList.SetFocus();
		return;
	}

	CByteBuffer SendBuff;
	SendBuff.FillWithHexString(strCommand);

	BYTE RecvBuff[1024];
	DWORD dwRecvLength = sizeof(RecvBuff);

	LONG lResult = F3_SamTransmit(g_hReader, m_bProtocol, SendBuff, SendBuff.GetLength(), RecvBuff, &dwRecvLength);


	CString strInfo;
	if (lResult == 0)
	{
		CString str;
		Bytes2HexString(RecvBuff, dwRecvLength, str);
		GetDlgItem(IDC_SAM_RESPONSE_BOX)->SetWindowText(str);

		strInfo.Format(_T("R-APDU: %s"), str);

		BOOL fFound = FALSE;
		for (int i = 0; i < m_CommandList.GetCount() && !fFound; i++)
		{
			m_CommandList.GetLBText( i, str);
			str.Remove(_T(' '));

			if (strCommand == str)
				fFound = TRUE;
		}
		
		if (! fFound)
		{
			Bytes2HexString( SendBuff, SendBuff.GetLength(), strCommand, ' ');
			m_CommandList.AddString( strCommand );
		}
	}

	CButton *pBtn = GetButton(IDC_SAM_TRANSMIT);
	CString strCmdName;
	pBtn->GetWindowText(strCmdName);

	OutputResult(lResult, strCmdName, strInfo);
}

void CSamPanel::SamReset(BOOL bCold)
{
	BYTE ATRBuff[32];
	DWORD ATRLength = sizeof(ATRBuff);
	CString strInfo;
	LONG lResult;

	if (bCold)
		lResult = F3_SamActivate(g_hReader, &m_bProtocol, ATRBuff, &ATRLength, m_bMode);
	else
		lResult = F3_SamWarmReset(g_hReader, &m_bProtocol, ATRBuff, &ATRLength);

	if (lResult == 0)
	{
		CString strATR;
		Bytes2HexString(ATRBuff, ATRLength, strATR);
		SetDlgItemText(IDC_SAM_ATR_BOX, strATR);

		CComboBox *pList = GetComboBox(IDC_SAM_PROTOCOL_LIST);
		CString s1;
		switch ( m_bProtocol )
		{
		case ICC_PROTOCOL_T0:
			s1 = _T("T = 0");
			pList->SetCurSel(0);
			break;
		case ICC_PROTOCOL_T1:
			s1 = _T("T = 1");
			pList->SetCurSel(1);
			break;
		}

		strInfo.Format(_T("Protocol: %s, ATR: %s"),s1, strATR);
	}

	OutputResult(lResult, GetFocus(), strInfo);
}

void CSamPanel::OnBnClickedSamSelect()
{
	LONG lResult = F3_SamSelect(g_hReader, m_bSAMNumber);
	OutputResult(lResult, GetFocus(), NULL);
}
