// SxxPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "SxxPanel.h"


// CSxxPanel Ի

IMPLEMENT_DYNAMIC(CSxxPanel, CPanelBase)

CSxxPanel::CSxxPanel(SXXTYPE iType, CWnd* pParent /*=NULL*/)
	: CPanelBase(CSxxPanel::IDD, pParent), m_iType(iType)
{

}

CSxxPanel::~CSxxPanel()
{
}

void CSxxPanel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SXX_PWD_GRID, m_PwdGrid);
	DDX_Control(pDX, IDC_SXX_DATA_GRID, m_DataGrid);
	DDX_Control(pDX, IDC_SXX_VALUE_BOX, m_ValueBox);
	DDX_Control(pDX, IDC_SXX_CAPTION, m_CapLab);
}


BEGIN_MESSAGE_MAP(CSxxPanel, CPanelBase)
	ON_CBN_SELCHANGE(IDC_SXX_SECTOR_NUMBER_LIST, &CSxxPanel::OnCbnSelchangeSxxSectorNumberList)
	ON_BN_CLICKED(IDC_SXX_VERIFY_PWD, &CSxxPanel::OnBnClickedSxxVerifyPwd)
	ON_BN_CLICKED(IDC_SXX_UPDATE_PWD, &CSxxPanel::OnBnClickedSxxUpdatePwd)
	ON_BN_CLICKED(IDC_SXX_LOAD_FROM_EEPROM, &CSxxPanel::OnBnClickedSxxLoadFromEeprom)
	ON_BN_CLICKED(IDC_SXX_DOWNLOAD_TO_EEPROM, &CSxxPanel::OnBnClickedSxxDownloadToEeprom)
	ON_CBN_SELCHANGE(IDC_SXX_START_BLOCK_NUMBER_LIST, &CSxxPanel::OnCbnSelchangeSxxStartBlockNumberList)
	ON_CBN_SELCHANGE(IDC_SXX_NUMBER_OF_BLOCKS, &CSxxPanel::OnCbnSelchangeSxxNumberOfBlocks)
	ON_BN_CLICKED(IDC_SXX_READ_BLOCKS, &CSxxPanel::OnBnClickedSxxReadBlocks)
	ON_BN_CLICKED(IDC_SXX_WRITE_BLOCKS, &CSxxPanel::OnBnClickedSxxWriteBlocks)
	ON_BN_CLICKED(IDC_SXX_READ_VALUE, &CSxxPanel::OnBnClickedSxxReadValue)
	ON_BN_CLICKED(IDC_SXX_INITIALIZE, &CSxxPanel::OnBnClickedSxxInitialize)
	ON_BN_CLICKED(IDC_SXX_INCREMENT, &CSxxPanel::OnBnClickedSxxIncrement)
	ON_BN_CLICKED(IDC_SXX_DECREMENT, &CSxxPanel::OnBnClickedSxxDecrement)
	ON_WM_ENABLE()
END_MESSAGE_MAP()


// CSxxPanel Ϣ


BOOL CSxxPanel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	CComboBox *pList;
	CString str;
	int	idx;

	pList = GetComboBox(IDC_SXX_KEY_TYPE_LIST);
	idx = pList->AddString(_T("Key A"));
	pList->SetItemData(idx, 1);
	idx = pList->AddString(_T("Key B"));
	pList->SetItemData(idx, 0);
	pList->SetCurSel(0);

	pList = GetComboBox(IDC_SXX_SECTOR_NUMBER_LIST);

	int LastSecNum = m_iType == S50 ? 0x0f : 0x28;
	for (int i = 0; i <= LastSecNum; i++)
	{
		str.Format(_T("%d"), i);
		idx = pList->AddString(str);
		pList->SetItemData(idx, i);
	}
	pList->SetCurSel(1);
	OnCbnSelchangeSxxSectorNumberList();

	m_PwdGrid.Init(1, 6, 0, 0);
	BYTE PwdBytes[] = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
	m_PwdGrid.Fill(PwdBytes, sizeof(PwdBytes));

	m_ValueBox.AllowHexInput();
	m_ValueBox.SetLimitText(8);
	m_ValueBox.SetValue(0);

	m_CapLab.SetBackgroundColor(RGB(0,0,128));
	m_CapLab.SetTextColor(RGB(255,255,255));

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CSxxPanel::OnCbnSelchangeSxxSectorNumberList()
{
	CComboBox *pSecList = GetComboBox(IDC_SXX_SECTOR_NUMBER_LIST);
	m_iSectorNum = (BYTE) pSecList->GetItemData(pSecList->GetCurSel());

	CComboBox *pBlkList1 = GetComboBox(IDC_SXX_START_BLOCK_NUMBER_LIST);
	CComboBox *pBlkList2 = GetComboBox(IDC_SXX_BLOCK_NUMBER_LIST);

	pBlkList1->ResetContent();
	pBlkList2->ResetContent();

	int LastBlkNum = 3;
	if (m_iType == S70 && m_iSectorNum > 31)
		LastBlkNum = 15;

	CString str;
	int idx;
	for (int i = 0; i <= LastBlkNum; i++)
	{
		str.Format(_T("%d"), i);
		idx = pBlkList1->AddString(str);
		pBlkList1->SetItemData(idx, i);
		idx = pBlkList2->AddString(str);
		pBlkList2->SetItemData(idx, i);
	}

	pBlkList1->SetCurSel(0);
	OnCbnSelchangeSxxStartBlockNumberList();

	pBlkList2->SetCurSel(0);
}


void CSxxPanel::OnBnClickedSxxVerifyPwd()
{
	PwdOp(PWDOT_VERIFY);
}


void CSxxPanel::OnBnClickedSxxUpdatePwd()
{
	PwdOp(PWDOT_UPDATE);
}


void CSxxPanel::OnBnClickedSxxLoadFromEeprom()
{
	CComboBox *pList = GetComboBox(IDC_SXX_KEY_TYPE_LIST);
	BOOL bWithKeyA = (BOOL) pList->GetItemData(pList->GetCurSel());

	LONG lResult = F3_MfLoadPassword(g_hReader, m_iSectorNum, bWithKeyA);
	OutputResult(lResult, GetFocus(), NULL);
}


void CSxxPanel::OnBnClickedSxxDownloadToEeprom()
{
	PwdOp(PWDOT_DOWNLOAD);
}


void CSxxPanel::OnCbnSelchangeSxxStartBlockNumberList()
{
	CComboBox *pBlkList1 = GetComboBox(IDC_SXX_START_BLOCK_NUMBER_LIST);
	int iBlkNum = pBlkList1->GetItemData(pBlkList1->GetCurSel());

	CComboBox *pBlocksList = GetComboBox(IDC_SXX_NUMBER_OF_BLOCKS);
	pBlocksList->ResetContent();

	int nMaxBlkCount;

	if (m_iType == S70 && 
		m_iSectorNum > 31)
		nMaxBlkCount = 16 - iBlkNum;
	else
		nMaxBlkCount = 4 - iBlkNum;

	CString str;
	int idx;
	for (int i = 1; i <= nMaxBlkCount; i++)
	{
		str.Format(_T("%d"), i);
		idx = pBlocksList->AddString(str);
		pBlocksList->SetItemData(idx, i);
	}

	pBlocksList->SetCurSel(0);
	OnCbnSelchangeSxxNumberOfBlocks();

	
	CComboBox *pList = GetComboBox(IDC_SXX_BLOCK_NUMBER_LIST); 
	pList->SetCurSel(iBlkNum);
}


void CSxxPanel::OnCbnSelchangeSxxNumberOfBlocks()
{
	CComboBox *pBlocksList = GetComboBox(IDC_SXX_NUMBER_OF_BLOCKS);
	int nBlockCount = pBlocksList->GetItemData(pBlocksList->GetCurSel());

	int nCells = 16 * nBlockCount;
	long lTotalRows = (nCells + 15) / 16 + 1;

	m_DataGrid.Init(lTotalRows, 17, 1, 1);
	m_DataGrid.InitRowHeader();
	m_DataGrid.InitColumnHeader();
	m_DataGrid.SetEditableCells(nCells);
}


void CSxxPanel::OnBnClickedSxxReadBlocks()
{
	CComboBox *pList1 = GetComboBox(IDC_SXX_START_BLOCK_NUMBER_LIST);
	CComboBox *pList2 = GetComboBox(IDC_SXX_NUMBER_OF_BLOCKS);

	BYTE iStartBlkNum = (BYTE) pList1->GetItemData(pList1->GetCurSel());
	BYTE bBlockCount = (BYTE) pList2->GetItemData(pList2->GetCurSel());

	BYTE pbBuff[256];
	DWORD wLength = sizeof(pbBuff);

	LONG lResult = F3_MfReadSector(g_hReader, m_iSectorNum, iStartBlkNum, pbBuff, &wLength);
	OutputResult(lResult, GetFocus(), NULL);

	m_DataGrid.ResetContent();

	if (lResult == 0)
		m_DataGrid.Fill(pbBuff, wLength);
}


void CSxxPanel::OnBnClickedSxxWriteBlocks()
{
	if (! m_DataGrid.ValidateInput())
		return;

	CComboBox *pList1 = GetComboBox(IDC_SXX_START_BLOCK_NUMBER_LIST);
	CComboBox *pList2 = GetComboBox(IDC_SXX_NUMBER_OF_BLOCKS);  

	BYTE iStartBlkNum = (BYTE) pList1->GetItemData(pList1->GetCurSel());
	BYTE bBlockCount = (BYTE) pList2->GetItemData(pList2->GetCurSel());

	BYTE pbBuff[256];
	WORD dwLength = (WORD) m_DataGrid.GetContent(pbBuff, sizeof(pbBuff));



	LONG lResult = F3_MfWriteSector(g_hReader, m_iSectorNum, iStartBlkNum, bBlockCount * 16, pbBuff);
	OutputResult(lResult, GetFocus(), NULL);

	if (lResult == 0)
		m_DataGrid.ResetContent();
}


void CSxxPanel::OnBnClickedSxxReadValue()
{
	ValOp(VOT_READ);
}


void CSxxPanel::OnBnClickedSxxInitialize()
{
	ValOp(VOT_INIT);
}


void CSxxPanel::OnBnClickedSxxIncrement()
{
	ValOp(VOT_INC);
}


void CSxxPanel::OnBnClickedSxxDecrement()
{
	ValOp(VOT_DEC);
}


void CSxxPanel::PwdOp(PWDOPTYPE iType)
{
	if (! m_PwdGrid.ValidateInput())
		return;

	CComboBox *pList = GetComboBox(IDC_SXX_KEY_TYPE_LIST);
	BOOL bWithKeyA = (BOOL) pList->GetItemData(pList->GetCurSel());




	BYTE KeyBytes[6];
	m_PwdGrid.GetContent(KeyBytes, sizeof(KeyBytes));

	LONG lResult;

	
	if (iType == PWDOT_VERIFY)
	{
		lResult = F3_MfVerifyPassword(g_hReader, m_iSectorNum, bWithKeyA, KeyBytes);
	}
	else if (iType == PWDOT_UPDATE)  
	{
		lResult = F3_MfUpdatePassword(g_hReader, m_iSectorNum, KeyBytes);
	}
	else
	{
		lResult = F3_MfDownloadPassword(g_hReader, m_iSectorNum, bWithKeyA, KeyBytes);
	}

	OutputResult(lResult, GetFocus(), NULL);
}

void CSxxPanel::ValOp(VOTYPE iType)
{
	if (iType != VOT_READ &&
		! m_ValueBox.IsValidInput())
		return;

	CComboBox* pList = GetComboBox(IDC_SXX_BLOCK_NUMBER_LIST);
	BYTE iBlockNum = (BYTE) pList->GetItemData(pList->GetCurSel());
	UINT iValue = m_ValueBox.GetValue();

	LONG lResult;
	switch (iType)
	{
	case VOT_READ: 
		lResult = F3_MfReadValue(g_hReader,  m_iSectorNum, iBlockNum, &iValue); 
		m_ValueBox.SetValue(iValue);
		break;
	case VOT_INIT: 
		lResult = F3_MfInitializeValue(g_hReader, m_iSectorNum, iBlockNum, iValue); 
		break;
	case VOT_INC: 
		lResult = F3_MfIncrementValue(g_hReader, m_iSectorNum, iBlockNum, iValue); 
		break;
	case VOT_DEC: 
		lResult = F3_MfDecrementValue(g_hReader, m_iSectorNum, iBlockNum, iValue); 
		break;
	default: 
		return;
	}

	OutputResult(lResult, GetFocus(), NULL);
}

void CSxxPanel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);
	GetDlgItem(IDC_SXX_KEY_TYPE_LIST)->EnableWindow(bEnable);

	GetDlgItem(IDC_SXX_SECTOR_NUMBER_LIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_VERIFY_PWD)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_UPDATE_PWD)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_LOAD_FROM_EEPROM)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_DOWNLOAD_TO_EEPROM)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_START_BLOCK_NUMBER_LIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_BLOCK_NUMBER_LIST)->EnableWindow(bEnable);
	//GetDlgItem(IDC_SXX_NUMBER_OF_BLOCKS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_READ_BLOCKS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_WRITE_BLOCKS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_READ_VALUE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_INITIALIZE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_INCREMENT)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_DECREMENT)->EnableWindow(bEnable);
	GetDlgItem(IDC_SXX_VALUE_BOX)->EnableWindow(bEnable);
}
