#include "stdafx.h"
#include "common.h"
#include "resource.h"

#define NAME_ALIGN	40
#define MAX_LINE	50

READERHANDLE g_hReader = 0;
CRichEditCtrl* g_pOutWnd = NULL;


void LoadString(UINT nID, CString& strMsg)
{
	static TCHAR szBuff[128];
	::LoadString( NULL, nID, szBuff, sizeof(szBuff) / sizeof(TCHAR));
	strMsg = szBuff;
}


void GetResultMessage(LONG lResult, CString& strMsg)
{
	switch (lResult)
	{
	case F3_S_SUCCESS		: LoadString(IDS_SUCCESS, strMsg); break;
	case F3_E_PORT_UNAVAILABLE	: LoadString(IDS_PORT_UNAVAILABLE, strMsg); break;
	case F3_E_DEV_NOT_RECOGNIZED	: LoadString(IDS_DEV_NOT_RECOGNIZED, strMsg); break;
	case F3_E_COMM_ERROR		: LoadString(IDS_COMM_ERROR, strMsg); break;
	case F3_E_COMM_TIMEOUT		: LoadString(IDS_COMM_TIMEOUT, strMsg); break;
	case F3_E_UNKNOWN_ERROR		: LoadString(IDS_UNKNOWN_ERROR, strMsg); break;
	case F3_E_MESSAGE_TOO_LONG	: LoadString(IDS_MESSAGE_TOO_LONG, strMsg); break;
	case F3_E_NO_MEMORY		: LoadString(IDS_NO_MEMORY, strMsg); break;
	case F3_E_BUFFER_TOO_SMALL	: LoadString(IDS_BUFFER_TOO_SMALL, strMsg); break;
	case F3_E_INVALID_HANDLE	: LoadString(IDS_INVALID_HANDLE, strMsg); break;
	case F3_E_UNDEFINED_COMMAND	: LoadString(IDS_UNDEFINED_COMMAND, strMsg); break;
	case F3_E_INVALID_PARAMETER	: LoadString(IDS_INVALID_PARAMETER, strMsg); break;
	case F3_E_DISABLED_COMMAND	: LoadString(IDS_DISABLED_COMMAND, strMsg); break;
	case F3_E_UNSUPPORTED_COMMAND	: LoadString(IDS_UNSUPPORTED_COMMAND, strMsg); break;
	case F3_E_CONTACT_NO_RELEASE	: LoadString(IDS_CONTACT_NO_RELEASE, strMsg); break;
	case F3_E_CARD_JAMMED		: LoadString(IDS_CARD_JAMMED, strMsg); break;
	case F3_E_SENSOR_ABNORMALITY	: LoadString(IDS_SENSOR_ABNORMALITY, strMsg); break;
	case F3_E_TOO_LONG_CARD		: LoadString(IDS_TOO_LONG_CARD, strMsg); break;
	case F3_E_TOO_SHORT_CARD	: LoadString(IDS_TOO_SHORT_CARD, strMsg); break;
	case F3_E_CARD_WITHDRAWN	: LoadString(IDS_CARD_WITHDRAWN, strMsg); break;
	case F3_E_IC_SOLENOID_ERROR	: LoadString(IDS_IC_SOLENOID_ERROR, strMsg); break;
	case F3_E_CANT_MOVED_TO_IC_POS	: LoadString(IDS_CANT_MOVED_TO_IC_POS, strMsg); break;
	case F3_E_CARD_POSITION_CHANGE	: LoadString(IDS_CARD_POSITION_CHANGE, strMsg); break;
	case F3_E_COUNTER_OVERFLOW	: LoadString(IDS_COUNTER_OVERFLOW, strMsg); break;
	case F3_E_MOTOR_ABNORMALITY	: LoadString(IDS_MOTOR_ABNORMALITY, strMsg); break;
	case F3_E_POWER_SHORT		: LoadString(IDS_POWER_SHORT, strMsg); break;
	case F3_E_ICC_ACTIVATION_ERROR	: LoadString(IDS_ICC_ACTIVATION_ERROR, strMsg); break;
	case F3_E_ICC_NOT_ACTIVATED	: LoadString(IDS_ICC_NOT_ACTIVATED, strMsg); break;
	case F3_E_UNSUPPORTED_ICC	: LoadString(IDS_UNSUPPORTED_ICC, strMsg); break;
	case F3_E_ICC_RECEPTION_ERROR	: LoadString(IDS_ICC_RECEPTION_ERROR, strMsg); break;
	case F3_E_ICC_COMM_TIMEOUT	: LoadString(IDS_ICC_COMM_TIMEOUT, strMsg); break;
	case F3_E_MISMATCH_EMV		: LoadString(IDS_MISMATCH_EMV, strMsg); break;
	case F3_E_CARD_BOX_EMPTY	: LoadString(IDS_CARD_BOX_EMPTY, strMsg); break;
	case F3_E_CAPTURE_BOX_FULL	: LoadString(IDS_CAPTURE_BOX_FULL, strMsg); break;
	case F3_E_WAITING_FOR_RESET	: LoadString(IDS_WAITING_FOR_RESET, strMsg); break;
	case F3_E_COMMAND_FAILURE	: LoadString(IDS_COMMAND_FAILURE, strMsg); break;
	case F3_E_DISAGREEMENT_OF_VC	: LoadString(IDS_DISAGREEMENT_OF_VC, strMsg); break;
	case F3_E_CARD_LOCKED		: LoadString(IDS_CARD_LOCKED, strMsg); break;
	case F3_E_ADDRESS_OVERFLOW	: LoadString(IDS_ADDRESS_OVERFLOW, strMsg); break;
	case F3_E_LENGTH_OVERFLOW	: LoadString(IDS_LENGTH_OVERFLOW, strMsg); break;
	case F3_E_NO_CARD_IN	: LoadString(IDS_NO_CARD_IN, strMsg); break;
	case NOCARD_OR_INFRONT : strMsg = _T("ͨûǰ˿Ƭδȡ");
	}
}

void SetOutputWnd(CRichEditCtrl *pOutWnd)
{
	g_pOutWnd = pOutWnd;
}


void OutputMessage(LPCTSTR lpszMsg, COLORREF clrText)
{
	if (g_pOutWnd == NULL)
		return;

	CHARFORMAT cFmt; 
	cFmt.cbSize = sizeof(CHARFORMAT);  
	cFmt.dwMask = CFM_COLOR | CFM_BOLD | CFM_SIZE;
	cFmt.dwEffects = CFE_BOLD;
	cFmt.crTextColor = clrText;
	cFmt.yHeight = 14*1440/96;

	g_pOutWnd->SetSel(-1, -1);
	g_pOutWnd->SetSelectionCharFormat(cFmt);
	g_pOutWnd->ReplaceSel(lpszMsg);
	g_pOutWnd->PostMessage(WM_VSCROLL, SB_BOTTOM,0); 
	g_pOutWnd->SetFocus();

	if (g_pOutWnd->GetLineCount() > MAX_LINE)
	{
		long EndChar = g_pOutWnd->LineIndex(g_pOutWnd->GetLineCount() - MAX_LINE);
		g_pOutWnd->SetSel(0, EndChar);
		g_pOutWnd->ReplaceSel( NULL );

		g_pOutWnd->PostMessage(WM_VSCROLL, SB_BOTTOM,0); 
		g_pOutWnd->SetFocus();
	}
}

void ClearOutput()
{
	if (g_pOutWnd != NULL)
		g_pOutWnd->SetWindowText(_T(""));
}

void OutputResult(LONG lResult, LPCTSTR lpszCmdName, LPCTSTR lpszAddiInfo)
{
	
	OutputResult(lResult, NULL, lpszCmdName, lpszAddiInfo);
}


void OutputResult(LONG lResult, LPCTSTR lpszCmdClass, LPCTSTR lpszCmdName, LPCTSTR lpszReplyData)
{
	if (g_pOutWnd == NULL)
		return;

	CString strErr;
	GetResultMessage(lResult, strErr);

	SYSTEMTIME st;
	GetLocalTime(&st);

	CString strTitle;
	strTitle.Format(_T("%02d:%02d:%02d:%03d  "), st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
	strTitle += lpszCmdName;

	char  szTitle[128];
	int len = WideCharToMultiByte(CP_OEMCP,NULL, strTitle, -1, szTitle, sizeof(szTitle), NULL, FALSE);

	for (int i = 0; i < NAME_ALIGN - len; i++)
		strTitle.AppendChar( ' ');

	CString strMsg;
	if (lpszReplyData != NULL &&
		_tcslen(lpszReplyData) > 0)
	{
		strMsg.Format(_T("%s\t[%s]\r\n  [%s]\r\n\r\n"), strTitle, strErr, lpszReplyData);
	}
	else
	{
		strMsg.Format(_T("%s\t[%s]\r\n\r\n"), strTitle, strErr);
	}

	OutputMessage(strMsg, (lResult == 0) ? RGB(0,128,0) : RGB(255,0,0));
}


void OutputResult(LONG lResult, CWnd *pCmdWnd, LPCTSTR lpszAddiInfo)
{
	CString strCmdName;
	pCmdWnd->GetWindowText(strCmdName);
	OutputResult(lResult, strCmdName, lpszAddiInfo);
}


__forceinline char HexChar(BYTE digit)
{
	if (digit <= 9)
		return '0' + digit;
	else
		return 'A' + (digit - 10);
}

void Bytes2HexString(PBYTE pbBuffer, DWORD cbBuffer, CString& str, char splitter)
{
	str.Empty();

	for (DWORD i = 0; i < cbBuffer; i++)
	{
		str.AppendChar(HexChar(pbBuffer[i] / 16));
		str.AppendChar(HexChar(pbBuffer[i] % 16));
	}
}



void GetResultMessage2(LONG lResult, CString& strMsg)
{
	switch (lResult)
	{
	case SCARD_E_CANCELLED:		strMsg = _T("The action was canceled by an SCardCancel request."); break;
	case SCARD_E_CANT_DISPOSE:	strMsg = _T("The system could not dispose of the media in the requested manner."); break;
	case SCARD_E_CARD_UNSUPPORTED:	strMsg = _T("The smart card does not meet minimal requirements for support."); break;
	case SCARD_E_DUPLICATE_READER:	strMsg = _T("The reader driver didn't produce a unique reader name."); break;
	case SCARD_E_INSUFFICIENT_BUFFER: strMsg = _T("The data buffer for returned data is too small for the returned data."); break;
	case SCARD_E_INVALID_ATR:	strMsg = _T("An ATR string obtained from the registry is not a valid ATR string."); break;
	case SCARD_E_INVALID_HANDLE:	strMsg = _T("The supplied handle was invalid."); break;
	case SCARD_E_INVALID_PARAMETER:	strMsg = _T("One or more of the supplied parameters could not be properly interpreted."); break;
	case SCARD_E_INVALID_TARGET:	strMsg = _T("Registry startup information is missing or invalid."); break;
	case SCARD_E_INVALID_VALUE:	strMsg = _T("One or more of the supplied parameter values could not be properly interpreted."); break;
	case SCARD_E_NOT_READY:		strMsg = _T("The reader or card is not ready to accept commands."); break;
	case SCARD_E_NOT_TRANSACTED:	strMsg = _T("An attempt was made to end a non-existent transaction."); break;
	case SCARD_E_NO_MEMORY:		strMsg = _T("Not enough memory available to complete this command."); break;
	case SCARD_E_NO_SERVICE:	strMsg = _T("The smart card resource manager is not running."); break;
	case SCARD_E_NO_SMARTCARD:	strMsg = _T("The operation requires a smart card, but no smart card is currently in the device."); break;
	case SCARD_E_PCI_TOO_SMALL:	strMsg = _T("The PCI receive buffer was too small."); break;
	case SCARD_E_PROTO_MISMATCH:	strMsg = _T("The requested protocols are incompatible with the protocol currently in use with the card."); break;
	case SCARD_E_READER_UNAVAILABLE:strMsg = _T(" The specified reader is not currently available for use. "); break;
	case SCARD_E_READER_UNSUPPORTED:strMsg = _T("The reader driver does not meet minimal requirements for support."); break;
	case SCARD_E_SERVICE_STOPPED:	strMsg = _T("The smart card resource manager has shut down."); break;
	case SCARD_E_SHARING_VIOLATION:	strMsg = _T("The smart card cannot be accessed because of other outstanding connections."); break;
	case SCARD_E_SYSTEM_CANCELLED:	strMsg = _T("The action was canceled by the system, presumably to log off or shut down."); break;
	case SCARD_E_TIMEOUT:		strMsg = _T("The user-specified timeout value has expired."); break;
	case SCARD_E_UNKNOWN_CARD:	strMsg = _T("The specified smart card name is not recognized."); break;
	case SCARD_E_UNKNOWN_READER:	strMsg = _T("The specified reader name is not recognized."); break;
	case SCARD_F_COMM_ERROR:	strMsg = _T("An internal communications error has been detected."); break;
	case SCARD_F_INTERNAL_ERROR:	strMsg = _T("An internal consistency check failed."); break;
	case SCARD_F_WAITED_TOO_LONG:	strMsg = _T("An internal consistency timer has expired."); break;
	case SCARD_W_REMOVED_CARD:	strMsg = _T("The smart card has been removed, so that further communication is not possible."); break;
	case SCARD_W_RESET_CARD:	strMsg = _T("The smart card has been reset, so any shared state information is invalid."); break;
	case SCARD_W_UNPOWERED_CARD:	strMsg = _T("Power has been removed from the smart card, so that further communication is not possible."); break;
	case SCARD_W_UNRESPONSIVE_CARD:	strMsg = _T("The smart card is not responding to a reset. "); break;
	case SCARD_W_UNSUPPORTED_CARD:	strMsg = _T("The reader cannot communicate with the card, due to ATR string configuration conflicts."); break;
	}
}