// CmdEditDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "Public.h"



// CCmdEditDlg Ի

IMPLEMENT_DYNAMIC(CCmdEditDlg, CDialogEx)

CCmdEditDlg::CCmdEditDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_COMMAND_EDIT_DLG, pParent)
{
    m_cbCDTMinLength = 2;
    m_fnEditCallback = NULL;
    m_bAddNew = TRUE;
}

CCmdEditDlg::~CCmdEditDlg()
{
}

void CCmdEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_CMD_NAME_BOX, m_edtName);
    DDX_Control(pDX, IDC_CMD_DATA_BOX, m_edtData);
}


BEGIN_MESSAGE_MAP(CCmdEditDlg, CDialogEx)
END_MESSAGE_MAP()


// CCmdEditDlg Ϣ

BOOL CCmdEditDlg::OnInitDialog()
{
    CDialogEx::OnInitDialog();

    m_edtName.SetWindowText(m_cmdInfo.strName);
    m_edtData.SetWindowText(m_cmdInfo.strDispData);
    m_edtName.SetFocus();

    if (m_bAddNew)
        GetDlgItem(IDOK)->SetWindowText(_T(""));
    else
        GetDlgItem(IDOK)->SetWindowText(_T("ȷ"));

    return TRUE;
}

void CCmdEditDlg::OnOK()
{
    ASSERT(m_fnEditCallback != NULL);

    m_edtName.GetWindowText(m_cmdInfo.strName);
    m_cmdInfo.strName.Trim();
    if (m_cmdInfo.strName.GetLength() == 0)
    {
        AfxMessageBox(_T("ơ"), MB_OK | MB_ICONERROR);
        m_edtName.SetFocus();
        return;
    }

    m_edtData.GetWindowText(m_cmdInfo.strDispData);
    m_cmdInfo.strDispData.Trim();
    if (m_cmdInfo.strDispData.GetLength() == 0)
    {
        AfxMessageBox(_T("ݡ"), MB_OK | MB_ICONERROR);
        m_edtData.SetFocus();
        return;
    }

    if (!ValidData(m_cmdInfo.strDispData, m_cmdInfo.baData))
    {
        m_edtData.SetFocus();
        return;
    }

    m_fnEditCallback(m_pvParam, m_cmdInfo, m_bAddNew);
    memset(&m_cmdInfo, 0, sizeof(COMMANDINFO));

    if (m_bAddNew)
    {
        m_edtName.SetWindowText(NULL);
        m_edtData.SetWindowText(NULL);
        m_edtName.SetFocus();
        return;
    }

    CDialogEx::OnOK();
}


void CCmdEditDlg::SetCDTMinLength(DWORD cbCDTMinLength)
{
    m_cbCDTMinLength = cbCDTMinLength;
}


void CCmdEditDlg::SetEditCallback(FNCMDEDITCALLBACK fnEditCallback, LPVOID pvParam)
{
    ASSERT(fnEditCallback != NULL);
    m_fnEditCallback = fnEditCallback;
    m_pvParam = pvParam;
}


 void CCmdEditDlg::SetEditInfo(LPCOMMANDINFO lpCmdInfo, BOOL bAddNew)
 {
     if (lpCmdInfo != NULL)
        m_cmdInfo = *lpCmdInfo;
     m_bAddNew = bAddNew;
 }


bool CCmdEditDlg::ValidData(const CString& strData, CByteArray &baData)
{
    LPCTSTR p = strData;
    DWORD len = strData.GetLength();
    CString strHex, strError;

    while(*p)
    {
        if (*p == '\"')
        {
            ++p;
            while (*p && *p != '\"')
            {
                baData.Add((BYTE)*p++);
            }
            if (*p != '\"')
            {
                AfxMessageBox(_T("ȱ \" "), MB_OK | MB_ICONERROR);
                return false;
            }
            p++;
        }

        while(*p)
        {
            if (isxdigit(*p))
            {
                strHex.AppendChar(*p);
                p++;
            }
            else if (isspace(*p))
            {
                p++;
                continue;
            }
            else
            {
                strError.Format(_T("Чַ \'%c\'"), *p);
                AfxMessageBox(strError, MB_OK | MB_ICONERROR);
                return false;
            }
        }

        if (strHex.GetLength() %2 != 0)
        {
           AfxMessageBox(_T("Ч"), MB_OK | MB_ICONERROR);
           return false;
        }
    }

    if (strHex.GetLength() > 0)
    {
        TUtils::HexStringToByteData(strHex,baData);
    }

    if (baData.GetCount() < m_cbCDTMinLength)
        {
            strError.Format(_T("Ҫ %d  ֽ"),m_cbCDTMinLength);
           AfxMessageBox(strError, MB_OK | MB_ICONERROR);
           return false;
        }
    return true;
}
