#include "StdAfx.h"
#include "Public.h"



BOOL CIniConfigFile::SetFilePath(LPCTSTR pszFilePath)
{
    m_strFilePath = pszFilePath;
    return TRUE;
}


BOOL CIniConfigFile::WriteValue(LPCTSTR pszGroup, LPCTSTR pszKey, DWORD dwValue)
{
    CString strValue;
    strValue.Format(_T("%d"), dwValue);
    return WritePrivateProfileString(pszGroup, pszKey, strValue, m_strFilePath);
}


BOOL CIniConfigFile::WriteValue(LPCTSTR pszGroup, LPCTSTR pszKey, double fValue)
{
    CString strValue;
    strValue.Format(_T("%lf"), fValue);
    return WritePrivateProfileString(pszGroup, pszKey, strValue, m_strFilePath);
}


BOOL CIniConfigFile::WriteValue(LPCTSTR pszGroup, LPCTSTR pszKey, LPCTSTR pszValue)
{
    return WritePrivateProfileString(pszGroup, pszKey, pszValue, m_strFilePath);
}


BOOL CIniConfigFile::WriteValue(LPCTSTR pszGroup, LPCTSTR pszKey, LPBYTE pbData, DWORD dwLength)
{
    CString strValue;
   TUtils:: ByteDataToHexString(pbData, dwLength, strValue);
    return WritePrivateProfileString(pszGroup, pszKey, strValue, m_strFilePath);
}


DWORD CIniConfigFile::ReadValue(LPCTSTR pszGroup, LPCTSTR pszKey, DWORD dwDefaultValue)
{
    return GetPrivateProfileInt(pszGroup, pszKey, dwDefaultValue, m_strFilePath);
}


double CIniConfigFile::ReadValue(LPCTSTR pszGroup, LPCTSTR pszKey, double fDefaultValue)
{
    TCHAR szValue[128];
    CString strDefault;
    strDefault.Format(_T("%lf"), fDefaultValue);
    GetPrivateProfileString(pszGroup, pszKey, strDefault, szValue, 128, m_strFilePath);
    return _tstof(szValue);
}


void CIniConfigFile::ReadValue(LPCTSTR pszGroup, LPCTSTR pszKey, CString &strValue)
{
    TCHAR szValue[1024];
    GetPrivateProfileString(pszGroup, pszKey, NULL, szValue, 1024, m_strFilePath);
    strValue = szValue;
}


void CIniConfigFile::ReadValue(LPCTSTR pszGroup, LPCTSTR pszKey, CByteArray &bytes)
{
    TCHAR szValue[4096];
    DWORD dwLength = GetPrivateProfileString(pszGroup, pszKey, NULL, szValue, 4096, m_strFilePath);
    TUtils::HexStringToByteData(szValue, dwLength, bytes);
}
