#include "StdAfx.h"
#include "Public.h"


static char HexChar(int d)
{
	if (d <= 9)
		return '0' + d;
	else
		return 'A' + (d - 10);
}


static int HexInt(int ch)
{
    return isdigit(ch)? ch - '0' : (ch | 0x20) - 'a' + 10;
}


void TUtils::ByteDataToHexString(CByteArray &baData, CString &strText, char chSplitter)
{
    ByteDataToHexString((LPBYTE)baData.GetData(), baData.GetCount(), strText, chSplitter);
}


void TUtils::ByteDataToHexString(LPBYTE pbData, DWORD dwLength, CString &strText, char chSplitter)
{
	strText.Empty();

    if (pbData == NULL || dwLength == 0)
        return;

    for (DWORD i = 0; i < dwLength; i++)
    {
        strText.AppendChar(HexChar(pbData[i] / 16));
        strText.AppendChar(HexChar(pbData[i] % 16));
        strText.AppendChar(chSplitter);
    }

    strText.Delete(strText.GetLength() - 1);
}


void TUtils::HexStringToByteData(const CString& strText, CByteArray &baData)
{
    HexStringToByteData(strText, strText.GetLength(), baData);
}


void TUtils::HexStringToByteData(LPCTSTR pszText, DWORD dwLength, CByteArray &baData)
{
	if (pszText == NULL || dwLength == 0)
        return;

    CString strText(pszText, dwLength);
    strText.Remove(_T(' '));
    strText.Remove(_T('\t'));
    strText.Remove(_T('\r'));
    strText.Remove(_T('\n'));
    
    dwLength = strText.GetLength();
    DWORD cchBytes = dwLength >> 1;
    baData.RemoveAll();

    BYTE b;
    for (DWORD i = 0; i < cchBytes; i++)
    {
        b = HexInt(strText[i*2]) << 4;
        b |= HexInt(strText[i*2+1]);
        baData.Add(b);
    }

	if (dwLength %2 != 0)
    {
        b = HexInt(strText[dwLength-1]);
        baData.Add(b);
    }
}


void TUtils::StringToByteData(LPCTSTR pszText, DWORD dwLength, CByteArray &baData)
{
}

void TUtils::ListCOMPorts(UIComboBox *pCbo)
{
	TCHAR szName[32];
	HANDLE hFile;
    BOOL fValid;

	for (DWORD iPort = 1; iPort <= 256; iPort++)
	{
		_stprintf_s(szName, _T("\\\\.\\COM%d"), iPort);

		fValid = FALSE;
		hFile =  CreateFile(szName, 
			GENERIC_READ | GENERIC_WRITE, 
			0, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
		{
			if (GetLastError() != ERROR_FILE_NOT_FOUND)
				fValid = TRUE;
		}
		else
		{
			fValid = TRUE;
			CloseHandle(hFile);
		}

		if (fValid)
		{
			_stprintf_s(szName, _T("COM%d"), iPort);
            pCbo->AddItem(szName, iPort);
		}
	}
}


LPCTSTR TUtils::GetAppStartupPath()
{
	static TCHAR szPath[MAX_PATH];
	GetModuleFileName(NULL, szPath, MAX_PATH);
	(_tcsrchr(szPath, _T('\\')))[1] = 0;
	return szPath;
}


BOOL TUtils::ExitOnInitFailed(CWnd *pWnd, LPCTSTR pszInfo)
{
	CString strMsg;
	strMsg = _T("ʼʧ");
	if (pszInfo != NULL)
		strMsg.AppendFormat(_T(": %s"), pszInfo);
	AfxMessageBox(strMsg, MB_OK | MB_ICONERROR);
	return FALSE;
}