﻿using System;
using System.Globalization;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MTK571TESTDLL;

namespace MTK571TEST
{
    public partial class ReaderResetBtn : Form
    {
        UInt32 Hdle = 0;

        public ReaderResetBtn()
        {
            InitializeComponent();
            CPUAPDUCOMMAND.SelectedIndex = 0;
        }

        private void OpenCommBtn_Click(object sender, EventArgs e)
        {
            Hdle = DllClass.CommOpen(PortCombo.Text);
            if (Hdle != 0)
            {
                CommPortStatusLabel.Text = "Comm. Port is Opened";
            }
            else
            {
                CommPortStatusLabel.Text = "Open Comm. Port Error";
            }
        }

        private void CloseCommBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                int i = DllClass.CommClose(Hdle);
                Hdle = 0;
                CommPortStatusLabel.Text = "Comm. Port is Closed";
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x30;
                Pm = 0x30;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("INITIALIZE OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "INITIALIZE");
                    }
                    else
                    {
                        MessageBox.Show("INITIALIZE ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "INITIALIZE");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void CardStatusBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x31;
                Pm = 0x30;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Card Status OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "Card Status");
                    }
                    else
                    {
                        MessageBox.Show("Card Status ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Card Status");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void SensorStatusBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x31;
                Pm = 0x31;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Sensor Status OK" + "\r\n"
                            + "Sensor 1 (PSS1):    " + Convert.ToString(RxData[0], 16) + "\r\n"
                            + "Sensor 2 (PSS2):    " + Convert.ToString(RxData[1], 16) + "\r\n"
                            + "Sensor 3 (PSS3):    " + Convert.ToString(RxData[2], 16) + "\r\n"
                            + "Sensor 4 (PSS4):    " + Convert.ToString(RxData[3], 16) + "\r\n"
                            + "Sensor 5 (PSS5):    " + Convert.ToString(RxData[4], 16) + "\r\n"
                            + "Sensor 6 (PSS6):    " + Convert.ToString(RxData[5], 16) + "\r\n"
                            + "Sensor 7 (PSS7):    " + Convert.ToString(RxData[6], 16) + "\r\n"
                            + "Sensor 8 (PSS8):    " + Convert.ToString(RxData[7], 16) + "\r\n"
                            + "Sensor 9 (PSS9):    " + Convert.ToString(RxData[8], 16) + "\r\n"
                            + "Sensor 10 (PSS10):  " + Convert.ToString(RxData[9], 16) + "\r\n"
                            + "Sensor KS1 (KS1):   " + Convert.ToString(RxData[10], 16) + "\r\n"
                            + "Sensor KS2 (KS2):   " + Convert.ToString(RxData[11], 16), "Sensor Status");
                    }
                    else
                    {
                        MessageBox.Show("Sensor Status ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Sensor Status");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void AllCardInBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x33;
                Pm = 0x30;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Allowed card in OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "Allowed card in");
                    }
                    else
                    {
                        MessageBox.Show("Allowed card in ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Allowed card in");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void NoCardInBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x33;
                Pm = 0x31;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Prohibition card in OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "Prohibition card in");
                    }
                    else
                    {
                        MessageBox.Show("Prohibition card in ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Prohibition card in");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void MoveCardToFront1Btn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x32;
                Pm = 0x39;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Move Card OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "Move Card");
                    }
                    else
                    {
                        MessageBox.Show("Move Card ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Move Card");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void MoveCardToFront2Btn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x32;
                Pm = 0x30;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Move Card OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "Move Card");
                    }
                    else
                    {
                        MessageBox.Show("Move Card ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Move Card");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void MoveCardToRFBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x32;
                Pm = 0x32;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Move Card OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "Move Card");
                    }
                    else
                    {
                        MessageBox.Show("Move Card ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Move Card");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void MoveCardToICCBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x32;
                Pm = 0x31;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Move Card OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "Move Card");
                    }
                    else
                    {
                        MessageBox.Show("Move Card ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Move Card");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void MoveCardToRecycleBinBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x32;
                Pm = 0x33;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Move Card OK" + "\r\n"+"Status Code : "+(char)St0+(char)St1+(char)St2, "Move Card");
                    }
                    else
                    {
                        MessageBox.Show("Move Card ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Move Card");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void CPUColdResetBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x51;
                Pm = 0x30;
                St0 = St1 = St2 = 0;
                TxDataLen = 1;
                RxDataLen = 0;

                if (CPUModeOption1.Checked)
                {
                    TxData[0] = 0x30;
                }
                else
                {
                    TxData[0] = 0x33;
                }
                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        int n;
                        string StrBuf = "";

                        for (n = 1; n < RxDataLen; n++)
                        {
                            StrBuf += RxData[n].ToString("X2");
                        }
                        CPUResetText.Text = StrBuf;
                        if (CPUModeOption1.Checked)
                        {
                            switch (RxData[0])
                            {
                                case 48:
                                    MessageBox.Show("CPU Card(T=0) Activate Successed and CPU card information meet the EMV mode ATR", "Cold Reset");
                                    break;
                                case 49:
                                    MessageBox.Show("CPU Card(T=1) Activate Successed and CPU card information meet the EMV mode ATR", "Cold Reset");
                                    break;
                            }
                        }
                        else
                        {
                            switch (RxData[0])
                            {
                                case 48:
                                    MessageBox.Show("CPU Card(T=0) Activate Successed", "Cold Reset");
                                    break;
                                case 49:
                                    MessageBox.Show("CPU Card(T=1) Activate Successed", "Cold Reset");
                                    break;
                            }
                        }
                    }
                    else if ((ReType == 0x4E) && (RxDataLen > 1))
                    {
                        int n;
                        string StrBuf = "";

                        for (n = 1; n < RxDataLen; n++)
                        {
                            StrBuf += RxData[n].ToString("X2");
                        }
                        CPUResetText.Text = StrBuf;
                        if (CPUModeOption1.Checked)
                        {
                            switch (RxData[0])
                            {
                                case 48:
                                    MessageBox.Show("CPU Card(T=0) Activate Successed,But CPU card information does not meet the EMV mode ATR", "Cold Reset");
                                    break;
                                case 49:
                                    MessageBox.Show("CPU Card(T=1) Activate Successed,But CPU card information does not meet the EMV mode ATR", "Cold Reset");
                                    break;
                            }
                        }
                        else
                        {
                            switch (RxData[0])
                            {
                                case 48:
                                    MessageBox.Show("CPU Card(T=0) Activate Successed", "Cold Reset");
                                    break;
                                case 49:
                                    MessageBox.Show("CPU Card(T=1) Activate Successed", "Cold Reset");
                                    break;
                            }
                        }
                    }
                    else
                    {
                        MessageBox.Show("Cold Reset ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Cold Reset");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void CPUWarmResetBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x51;
                Pm = 0x30;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        int n;
                        string StrBuf = "";

                        for (n = 1; n < RxDataLen; n++)
                        {
                            StrBuf += RxData[n].ToString("X2");
                        }
                        CPUResetText.Text = StrBuf;
                        if (CPUModeOption1.Checked)
                        {
                            switch (RxData[0])
                            {
                                case 48:
                                    MessageBox.Show("CPU Card(T=0) Activate Successed and CPU card information meet the EMV mode ATR", "Warm Reset");
                                    break;
                                case 49:
                                    MessageBox.Show("CPU Card(T=1) Activate Successed and CPU card information meet the EMV mode ATR", "Warm Reset");
                                    break;
                            }
                        }
                        else
                        {
                            switch (RxData[0])
                            {
                                case 48:
                                    MessageBox.Show("CPU Card(T=0) Activate Successed", "Warm Reset");
                                    break;
                                case 49:
                                    MessageBox.Show("CPU Card(T=1) Activate Successed", "Warm Reset");
                                    break;
                            }
                        }
                    }
                    else if ((ReType == 0x4E) && (RxDataLen > 1))
                    {
                        int n;
                        string StrBuf = "";

                        for (n = 1; n < RxDataLen; n++)
                        {
                            StrBuf += RxData[n].ToString("X2");
                        }
                        CPUResetText.Text = StrBuf;
                        if (CPUModeOption1.Checked)
                        {
                            switch (RxData[0])
                            {
                                case 48:
                                    MessageBox.Show("CPU Card(T=0) Activate Successed,But CPU card information does not meet the EMV mode ATR", "Warm Reset");
                                    break;
                                case 49:
                                    MessageBox.Show("CPU Card(T=1) Activate Successed,But CPU card information does not meet the EMV mode ATR", "Warm Reset");
                                    break;
                            }
                        }
                        else
                        {
                            switch (RxData[0])
                            {
                                case 48:
                                    MessageBox.Show("CPU Card(T=0) Activate Successed", "Warm Reset");
                                    break;
                                case 49:
                                    MessageBox.Show("CPU Card(T=1) Activate Successed", "Warm Reset");
                                    break;
                            }
                        }
                    }
                    else
                    {
                        MessageBox.Show("Warm Reset ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Warm Reset");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void SendAPDUbtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x51;
                Pm = 0x39;
                St0 = St1 = St2 = 0;
                TxDataLen = (UInt16) (CPUAPDUCOMMAND.Text.Length / 2);
                RxDataLen = 0;

                CpuBackText.Text = "";

                for (int N = 0; N < (CPUAPDUCOMMAND.Text.Length / 2); N++)
                {
                    TxData[N] = byte.Parse(CPUAPDUCOMMAND.Text.Substring(N * 2, 2), NumberStyles.HexNumber);
                }
                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        int n;
                        string StrBuf = "";

                        for (n = 0; n < RxDataLen; n++)
                        {
                            StrBuf += RxData[n].ToString("X2");
                        }
                        CpuBackText.Text = StrBuf;
                        MessageBox.Show("Send APDU Success", "Send APDU");
                    }
                    else
                    {
                        MessageBox.Show("Send APDU ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Send APDU");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void CPUDownbtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x51;
                Pm = 0x32;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        MessageBox.Show("Power Off OK" + "\r\n" + "Status Code : " + (char)St0 + (char)St1 + (char)St2, "Power Off");
                    }
                    else
                    {
                        MessageBox.Show("Power Off ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "Power Off");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void RFTestTypeBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x31;
                Pm = 0x31;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        switch (RxData[0])
                        {
                            case 48:
                                switch (RxData[1])
                                {
                                    case 48:
                                        MessageBox.Show("Unknow Type", "RF Card Type");
                                        break;
                                }
                                break;
                            case 49:
                                switch (RxData[1])
                                {
                                    case 48:
                                        MessageBox.Show("S50)", "RF Card Type");
                                        break;
                                    case 49:
                                        MessageBox.Show("S70", "RF Card Type");
                                        break;
                                    case 50:
                                        MessageBox.Show("UL CARD", "RF Card Type");
                                        break;
                                }
                                break;
                            case 50:
                                switch (RxData[1])
                                {
                                    case 48:
                                        MessageBox.Show("Type A CPU", "RF Card Type");
                                        break;
                                }
                                break;
                            case 51:
                                switch (RxData[1])
                                {
                                    case 48:
                                        MessageBox.Show("Type B CPU", "RF Card Type");
                                        break;
                                }
                            break;
                        }
                    }
                    else
                    {
                        MessageBox.Show("RF Card Type ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "RF Card Type");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }

        private void ICTestTypeBtn_Click(object sender, EventArgs e)
        {
            if (Hdle != 0)
            {
                byte Addr;
                byte Cm, Pm;
                UInt16 TxDataLen, RxDataLen;
                byte[] TxData = new byte[1024];
                byte[] RxData = new byte[1024];
                byte ReType = 0;
                byte St0, St1, St2;

                Cm = 0x31;
                Pm = 0x31;
                St0 = St1 = St2 = 0;
                TxDataLen = 0;
                RxDataLen = 0;

                Addr = (byte)(byte.Parse(AddrComb.Text.Substring(0, 2), NumberStyles.Number));
                int i = DllClass.ExecuteCommand(Hdle, Addr, Cm, Pm, TxDataLen, TxData, ref ReType, ref St0, ref St1, ref St2, ref RxDataLen, RxData);
                if (i == 0)
                {
                    if (ReType == 0x50)
                    {
                        switch (RxData[0])
                        {
                            case 48:
                                switch (RxData[1])
                                {
                                    case 48:
                                        MessageBox.Show("Unknow Type", "IC Card Type");
                                        break;
                                }
                                break;
                            case 49:
                                switch (RxData[1])
                                {
                                    case 48:
                                        MessageBox.Show("CPU CARD(T=0)", "IC Card Type");
                                        break;
                                    case 49:
                                        MessageBox.Show("CPU CARD(T=1)", "IC Card Type");
                                        break;
                                }
                                break;
                            case 50:
                                switch (RxData[1])
                                {
                                    case 48:
                                        MessageBox.Show("SLE4442", "IC Card Type");
                                        break;
                                    case 49:
                                        MessageBox.Show("SLE4428", "IC Card Type");
                                        break;
                                }
                                break;
                            case 51:
                                switch (RxData[1])
                                {
                                    case 48:
                                        MessageBox.Show("24C01", "IC Card Type");
                                        break;
                                    case 49:
                                        MessageBox.Show("24C02", "IC Card Type");
                                        break;
                                    case 50:
                                        MessageBox.Show("24C04", "IC Card Type");
                                        break;
                                    case 41:
                                        MessageBox.Show("24C08", "IC Card Type");
                                        break;
                                    case 42:
                                        MessageBox.Show("24C16", "IC Card Type");
                                        break;
                                    case 53:
                                        MessageBox.Show("24C32", "IC Card Type");
                                        break;
                                    case 54:
                                        MessageBox.Show("24C64", "IC Card Type");
                                        break;
                                    case 55:
                                        MessageBox.Show("24C128", "IC Card Type");
                                        break;
                                    case 56:
                                        MessageBox.Show("24C256", "IC Card Type");
                                        break;
                                }
                                break;
                        }
                    }
                    else
                    {
                        MessageBox.Show("IC Card Type ERROR" + "\r\n" + "Error Code:  " + (char)St1 + (char)St2, "IC Card Type");
                    }

                }
                else
                {
                    MessageBox.Show("Communication Error", "Caution");
                }
            }
            else
            {
                MessageBox.Show("Comm. port is not Opened", "Caution");
            }
        }
    }
}