#include "stdafx.h"
#include <atlstr.h>

#define ACK	0x06
#define NAK	0x15
#define ENQ	0x05
#define	EOT	0x04
#define STX	0xF2
#define ETX	0x03
#define CMT	'C'

#define VID		0x4144 
#define PID		0x5248


class CAutoLock
{
private:
	LPCRITICAL_SECTION m_lpCS;
public:
	CAutoLock(LPCRITICAL_SECTION lpInitedCS)
		: m_lpCS(lpInitedCS)
	{
		EnterCriticalSection(m_lpCS);
	}

	~CAutoLock()
	{
		LeaveCriticalSection(m_lpCS);
	}
};


CCommServiceF3::CCommServiceF3()
: m_pPort(NULL),
m_usbConnect(FALSE)
{
    InitializeCriticalSection(&m_cs);
}


CCommServiceF3::~CCommServiceF3()
{
    Disconnect();
    DeleteCriticalSection(&m_cs);
}


static SUSER_HIDPare  User_hidPare[10];



/**************************************************************
*HID豸ö
***************************************************************/
SUSER_HIDPare  *IFH_EnumHIDDevice(WORD uVID, 
                                       WORD uPID, //USB VID PID  
                                       BOOL bPresentFlag, //豸ڱ־ 0Ҫ豸
                                       unsigned char *pHid_Fount) //N豸 Զͬ豸֣  
{  
    BOOL bRet = FALSE;  

    int iFoundCount = 0; //ҵƥ豸  
    GUID HidGuid; 

    for (char loop=0; loop<10;loop++)
    {
        User_hidPare[loop].hid_DevPath[0] = NULL;
        User_hidPare[loop].hid_Manufacturer[0] = NULL;
        User_hidPare[loop].hid_Productr[0] = NULL;
        User_hidPare[loop].hid_SerialNumber[0] = NULL;
        pHid_Fount[0] = 0;
    }

    HidD_GetHidGuid(&HidGuid);  
    DWORD dwFlage = DIGCF_DEVICEINTERFACE;  
    if (bPresentFlag)
        dwFlage |= DIGCF_PRESENT;
    HDEVINFO hdev = SetupDiGetClassDevs(&HidGuid,   
                                        NULL,   
                                        NULL,   
                                        dwFlage);  
    if (INVALID_HANDLE_VALUE != hdev)
    {
        int idev = 0;   
        while (! bRet)
        {
            SP_DEVICE_INTERFACE_DATA did = {0};  
            did.cbSize = sizeof(did);  
            if (SetupDiEnumDeviceInterfaces(hdev, 0,   &HidGuid,idev,  &did))
            {

                DWORD cbRequired = 0;  
                SetupDiGetDeviceInterfaceDetail(hdev,  &did,  0,   0,&cbRequired,   0);  
                if (ERROR_INSUFFICIENT_BUFFER == GetLastError())
                {
                    PSP_DEVICE_INTERFACE_DETAIL_DATA pdidd =  
                    (PSP_DEVICE_INTERFACE_DETAIL_DATA)LocalAlloc(LPTR,  cbRequired);  
                    if (pdidd)
                    {
                        pdidd->cbSize = sizeof(*pdidd);  
                        if (SetupDiGetDeviceInterfaceDetail(hdev,&did,pdidd, cbRequired, &cbRequired, 0))
                        {
                            HANDLE hDevHandle =   
                            CreateFile(pdidd->DevicePath,  
                                       GENERIC_READ | GENERIC_WRITE,  
                                       FILE_SHARE_READ | FILE_SHARE_WRITE,  
                                       NULL,  
                                       OPEN_EXISTING,  
                                       FILE_ATTRIBUTE_NORMAL,  
                                       NULL);  
                            if (INVALID_HANDLE_VALUE != hDevHandle)
                            {
                                // Ask the battery for its tag.  
                                HIDD_ATTRIBUTES hidAttributes = {0};                  
                                hidAttributes.Size = sizeof(hidAttributes);  
                                if (HidD_GetAttributes(hDevHandle, &hidAttributes))
                                {
                                    if ( hidAttributes.VendorID == uVID && hidAttributes.ProductID == uPID)
                                    {
                                        HidD_GetManufacturerString(hDevHandle,  User_hidPare[iFoundCount].hid_Manufacturer, MAX_PATH);  
                                        HidD_GetProductString(hDevHandle, User_hidPare[iFoundCount].hid_Productr, MAX_PATH);  
                                        HidD_GetSerialNumberString(hDevHandle, User_hidPare[iFoundCount].hid_SerialNumber, MAX_PATH);
                                        _tcscpy_s(User_hidPare[iFoundCount].hid_DevPath, MAX_PATH, pdidd->DevicePath); 
                                        iFoundCount++;  
                                    }
                                }
                                CloseHandle(hDevHandle);  
                            } else
                                DWORD dwErr = GetLastError();  
                        } else
                            DWORD dwErr = GetLastError();  
                        LocalFree(pdidd);  
                    }
                }
            } else if (ERROR_NO_MORE_ITEMS == GetLastError())
            {
                break;  
            }
            idev++; //for next device  
        }  
        SetupDiDestroyDeviceInfoList(hdev);  
    }
    User_hidPare[iFoundCount].hid_DevPath[0] = NULL;
    User_hidPare[iFoundCount].hid_Manufacturer[0] = NULL;
    User_hidPare[iFoundCount].hid_Productr[0] = NULL;
    User_hidPare[iFoundCount].hid_SerialNumber[0] = NULL;
    pHid_Fount[0] = iFoundCount;
    return User_hidPare;  
}

/**************************************************************
*ͨƷΨһкѡUSB豸 
* 
*أ>=0ʾص<0ʾ޸豸 
***************************************************************/
long WINAPI IFH_SelUSBPort(char *pSN){
    unsigned char loop;
    char PrSN[128];

    for (loop=0; loop<10;loop++)
    {
        if (User_hidPare[loop].hid_DevPath[0]!=NULL)
        {
            int nLen = wcslen(User_hidPare[loop].hid_DevPath)+1;
            WideCharToMultiByte(CP_ACP,   
                                0,   
                                User_hidPare[loop].hid_DevPath,  
                                nLen,   
                                PrSN,   
                                2*nLen,   NULL,   NULL);
            if (strcmp(PrSN,pSN)==0)
                return loop;
        }
    }
    return(-1);
}
/**************************************************************
* 
*˵ dwPortNumberΪ0ʱ򣬱ʾUSBӿ   ʱdwBpsʾUSB
***************************************************************/
long 
CCommServiceF3::Connect(
                     IN DWORD  dwPortNumber,
                     IN DWORD  dwBps,
					 IN BYTE bAddress,
                     __in_opt LPCSTR pszLogDir
                     )
{
    long ret;
    char szPortName[128];

    unsigned char bhidcnt;
    SUSER_HIDPare *pUser_hidPare;

   m_Address = 	bAddress;
    m_logg.Initialize(pszLogDir, "F3_API");
    if (dwPortNumber == 0)
    {
        m_pPort = new CUsbPort();
        if (m_pPort != NULL)
        {
            if (User_hidPare[dwBps].hid_DevPath==NULL)
            {
                pUser_hidPare = IFH_EnumHIDDevice(VID,PID,TRUE,&bhidcnt);
                if (pUser_hidPare[dwBps].hid_DevPath==NULL)
                    return F3_E_COMM_ERROR;
            }
            //wchar תchar
            int nLen = wcslen(User_hidPare[dwBps].hid_DevPath)+1;
            WideCharToMultiByte(CP_ACP,   
                                0,   
                                User_hidPare[dwBps].hid_DevPath,  
                                nLen,   
                                szPortName,   2*nLen,   NULL,   NULL);
           
        }
		m_usbConnect = TRUE;
    } else
    {
        m_pPort = new CSerialPort();
        sprintf_s(szPortName,
                  sizeof(szPortName),
                  "\\\\.\\COM%d",
                  dwPortNumber);
        if (m_pPort == NULL)
            return F3_E_NO_MEMORY;  
    }
    ret = m_pPort->Initialize(szPortName,dwBps,&m_logg);
    if (ret != 0)
        return ret;
    return 0;
}
void 
CCommServiceF3::Disconnect()
{
    CAutoLock lock(&m_cs);

    if (m_pPort != NULL)
    {
        m_pPort->Release();
        m_pPort = NULL;
    }
	m_usbConnect = FALSE;
    m_logg.Release();
}

long CCommServiceF3::Execute(IN BYTE bCMDByte1,IN BYTE bCMDByte2,IN PBYTE pbCMPBuff,IN USHORT cbCMPLength,__in_opt PBYTE pbRDTBuff,__in_opt  PDWORD pcbRDTLength,OUT PCRSTATUS pStatus)
{

	LONG lRet;
	CAutoLock lock(&m_cs);
	lRet = m_pPort->ResetInput();

	if (lRet != 0)
		return lRet;
    lRet = MakeMessage(bCMDByte1, bCMDByte2, pbCMPBuff, cbCMPLength);
	if (lRet != 0) return lRet;
	m_fInProgress = TRUE;

	lRet = TranControl();
	m_fInProgress = FALSE;
	if (lRet != 0)
		return lRet;

	lRet = ProcessResponseData(FALSE, pbRDTBuff, pcbRDTLength, pStatus);

	return  lRet;
}

LONG	CCommServiceF3::ExecApduCommand(BYTE bCMDByte1, BYTE bCMDByte2, BYTE bCLA, BYTE bINS, BYTE bP1, BYTE bP2, BYTE bLength, PBYTE pbSendData, PBYTE pbRecvData, PDWORD pcbRecvLength)
{
	LONG lRet;
	CAutoLock lock(&m_cs);
	lRet = m_pPort->ResetInput();

	if (lRet != 0)
		return lRet;
	lRet = MakeMessage(bCMDByte1, bCMDByte2, bCLA, bINS, bP1, bP2, bLength, pbSendData);
	if (lRet != 0) return lRet;
	m_fInProgress = TRUE;

	lRet = TranControl();
	m_fInProgress = FALSE;
	if (lRet != 0)
		return lRet;
	lRet = ProcessResponseData(TRUE, pbRecvData, pcbRecvLength, NULL);
	return  lRet;

}

LONG CCommServiceF3::TranControl()
{
	LONG lRet;
	BOOL fNeg;
	LONG lCnt = 0;

Resend:
	m_logg.Write("COMMAND BEGIN\r\n");
	lRet = SendCommand();
	if (lRet != 0)
		return lRet;

	lRet = RecvACK(&fNeg);
	if (lRet != 0)
		return lRet;
	

	/*lRet = WaitForResponse();
	*/

	lRet = RecvResponse();
	if(lRet != 0) return lRet;

	lRet = SendACK();

	m_logg.Write("COMMAND END: Return %d\r\n\r\n\r\n", lRet);
	return lRet;
}

static LONG GetResults(BYTE e0, BYTE e1)
{
#define ERRMAP(_e0, _e1, _res) \
	if (e0 == _e0 && e1 == _e1)	return _res;

#include "errmap.h"

	return F3_E_UNKNOWN_ERROR;
}


LONG	CCommServiceF3::ProcessResponseData(BOOL bHasSW, PBYTE pbRecvData, PDWORD pcbRecvLength, PCRSTATUS pStatus)
{
	UINT RDTLen = m_dwMsgLen - 12;

	if (m_bMsgBuff[4] == 'N') // 0x4E
		return GetResults(m_bMsgBuff[7], m_bMsgBuff[8]);
	else if (m_bMsgBuff[4] != 'P' ) 
		return F3_E_COMM_ERROR;

	if (pStatus != NULL )
	{
		//  ST0ST1ST2 ֵǷͨЭ϶ֵ/
		//
		if ( !( m_bMsgBuff[7] >= 0x30 && m_bMsgBuff[7] <= 0x32))
			return F3_E_COMM_ERROR;
		if (! (m_bMsgBuff[8] >= 0x30 && m_bMsgBuff[8] <= 0x32))
			return F3_E_COMM_ERROR;
		if (! (m_bMsgBuff[9] >= 0x30 && m_bMsgBuff[9] <= 0x31))
			return F3_E_COMM_ERROR;

		pStatus->bLaneStatus = m_bMsgBuff[7];
		pStatus->bCardBoxStatus = m_bMsgBuff[8];
		pStatus->fCaptureBoxFull = m_bMsgBuff[9] == 0x31;
	}

	if (bHasSW)
	{
		RDTLen -= 2;

		LONG SW1 = m_bMsgBuff[m_dwMsgLen - 4];
		LONG SW2 = m_bMsgBuff[m_dwMsgLen - 3];

// 		CString str;
// 		str.Format(_T("SW1 = %02x  SW2 = %02x "),SW1,SW2);
// 		MessageBox(NULL,str,0,0);

		if (SW1 == 0x90 && SW2 == 0)
			goto L2;
		else if (SW1 == 0x6F && SW2 == 0)
			return F3_E_COMMAND_FAILURE; // ʧ
		else if (SW1 == 0x6F && SW2 == 0x1)
			return F3_E_DISAGREEMENT_OF_VC; // 벻ȷ
		else if (SW1 == 0x6F && SW2 == 0x2)
			return F3_E_CARD_LOCKED; // Ƭ
		else if (SW1 == 0x6B && SW2 == 0)
			return F3_E_ADDRESS_OVERFLOW; // ַ
		else if (SW1 == 0x67 && SW2 == 0)
			return F3_E_LENGTH_OVERFLOW; // 
		else
			return F3_E_COMMAND_FAILURE;
	}

L2:

	if (pbRecvData != NULL
		&& pcbRecvLength != NULL)
	{
		
		if (*pcbRecvLength < RDTLen){

			
			return F3_E_BUFFER_TOO_SMALL;
		}
		*pcbRecvLength = RDTLen;
		memcpy( pbRecvData, &m_bMsgBuff[10], RDTLen);
	}

	return 0;
}



long 
CCommServiceF3::MakeMessage(__in BYTE bCMDByte1,__in  BYTE bCMDByte2,__in  PBYTE pbCMPBuff, __in USHORT cbCMPLength)
{
	USHORT nTextLength = 3;	// CMT + CM + PM
	if (pbCMPBuff != NULL
		&& cbCMPLength > 0)
		nTextLength += cbCMPLength;

	if (nTextLength > MAX_MSG_LENGTH - 6)
		return F3_E_MESSAGE_TOO_LONG;
	m_dwMsgLen = 0;
	m_bMsgBuff[m_dwMsgLen++] = STX;
	m_bMsgBuff[m_dwMsgLen++] = m_Address;
	m_bMsgBuff[m_dwMsgLen++] = (BYTE) HIBYTE(nTextLength);
	m_bMsgBuff[m_dwMsgLen++] = (BYTE) LOBYTE(nTextLength);
	m_bMsgBuff[m_dwMsgLen++] = CMT;
	m_bMsgBuff[m_dwMsgLen++] = bCMDByte1;
	m_bMsgBuff[m_dwMsgLen++] = bCMDByte2;

	if (nTextLength > 3)
	{
		memcpy(&m_bMsgBuff[m_dwMsgLen], pbCMPBuff, cbCMPLength);
		m_dwMsgLen += cbCMPLength;
	}

	m_bMsgBuff[m_dwMsgLen++] = ETX;
	m_dwMsgLen++;	// + BCC
	m_bMsgBuff[m_dwMsgLen - 1] = GetBCC(m_bMsgBuff, m_dwMsgLen);


	return 0;
}

LONG	CCommServiceF3::MakeMessage(BYTE bCMDByte1, BYTE bCMDByte2, BYTE bCLA, BYTE bINS, BYTE bP1, BYTE bP2, BYTE bLength, PBYTE pbSendData)
{
	BOOL bWriteSec = FALSE;
	if ( bCMDByte1 == 0x60 && bCMDByte2 == 0x33 && bCLA == 0x0 && bINS == 0xD1 )
		bWriteSec = TRUE;


	USHORT nTextLength = 8;	// CMT + CM + PM
	if (pbSendData != NULL
		&& bLength > 0)
		nTextLength += bLength;

	if (nTextLength == 8
		&& bLength == 0)
		nTextLength -= 1;

	if (nTextLength > MAX_MSG_LENGTH - 6)
		return F3_E_MESSAGE_TOO_LONG;

	m_dwMsgLen = 0;
	m_bMsgBuff[m_dwMsgLen++] = STX;
	m_bMsgBuff[m_dwMsgLen++] = m_Address;
	m_bMsgBuff[m_dwMsgLen++] = (BYTE) HIBYTE(nTextLength);
	m_bMsgBuff[m_dwMsgLen++] = (BYTE) LOBYTE(nTextLength);
	m_bMsgBuff[m_dwMsgLen++] = CMT;
	m_bMsgBuff[m_dwMsgLen++] = bCMDByte1;
	m_bMsgBuff[m_dwMsgLen++] = bCMDByte2;

	m_bMsgBuff[m_dwMsgLen++] = bCLA;
	m_bMsgBuff[m_dwMsgLen++] = bINS;
	m_bMsgBuff[m_dwMsgLen++] = bP1;
	m_bMsgBuff[m_dwMsgLen++] = bP2;

	if (bLength > 0)
	{
		if ( bWriteSec )
			m_bMsgBuff[m_dwMsgLen++] = 1;
		else
			m_bMsgBuff[m_dwMsgLen++] = bLength;
	}

	if (nTextLength > 8)
	{
		memcpy(&m_bMsgBuff[m_dwMsgLen], pbSendData, bLength);
		m_dwMsgLen += bLength;
	}

	m_bMsgBuff[m_dwMsgLen++] = ETX;
	m_dwMsgLen++;	// + BCC
	m_bMsgBuff[m_dwMsgLen - 1] = GetBCC(m_bMsgBuff, m_dwMsgLen);

	return 0;
}




long 
CCommServiceF3::SendCommand()
{
    return m_pPort->WriteData(m_bMsgBuff, m_dwMsgLen);
}

long 
	CCommServiceF3::SendACK()
{
	BYTE Buff[] = {0x06};
	return m_pPort->WriteData(Buff, 1);
}


long 
CCommServiceF3::RecvACK( OUT LPBOOL pfNeg )
{

	
	int ret = m_pPort->WaitDataAvailable(5000);
	if (ret != 0 )
		return F3_E_COMM_TIMEOUT;

	BOOL bTimeOut;
	BYTE ACKBuff[1];
	DWORD BytesRead;
	while ( TRUE )
	{
		bTimeOut = FALSE;
		ret  = m_pPort->ReadData(ACKBuff, 1, &BytesRead);
		if (ret != 0)
		{
			if (bTimeOut)
				return F3_E_COMM_TIMEOUT;
			else
				return F3_E_UNKNOWN_ERROR;
		}

		if (ACKBuff[0] == ACK )
			return 0;
	}


	return 0;
}



LONG CCommServiceF3::WaitForResponse()
{
	if (m_pPort->WaitDataAvailable( 50000 ) != 0)
		return F3_E_COMM_TIMEOUT;

	BYTE MsgBuff[1];
	DWORD byteRead;
	while ( TRUE )
	{
		if (m_pPort->ReadData(MsgBuff, 1, &byteRead) != 0)
		{
				return F3_E_UNKNOWN_ERROR;
		}

		CString str;
		str.Format(_T(" WaitForResponse ::MsgBuff[0] = %02x"),MsgBuff[0]);
		//MessageBox(NULL,str,0,0);
		if ( MsgBuff[0] == STX)
			return 0;
	}
}

long
CCommServiceF3::RecvResponse()
{
	BOOL bTimeOut;
	DWORD byteRead;

	int lRet = m_pPort->WaitDataAvailable( 50000 );
	if (lRet != 0)
		return F3_E_COMM_TIMEOUT;

	if(m_usbConnect)
	    lRet = m_pPort->ReadData(m_bMsgBuff,1024, &byteRead);
	else{

		 lRet = m_pPort->ReadData(m_bMsgBuff,4, &byteRead);
		 UINT nComRemainderBytes = ((m_bMsgBuff[2] << 8) | m_bMsgBuff[3]) + 2; // +2: for [ETX][BCC]
		 if ( nComRemainderBytes > MAX_MSG_LENGTH - 4)
			 return F3_E_MESSAGE_TOO_LONG;
		 if ( m_pPort->ReadData(&m_bMsgBuff[4], nComRemainderBytes,&byteRead) != 0)
		 {
			 return F3_E_COMM_TIMEOUT;
		 }
	}
	if ( lRet != 0)return F3_E_COMM_TIMEOUT;
	
	UINT nRemainderBytes = ((m_bMsgBuff[2] << 8) | m_bMsgBuff[3]) + 2; // +2: for [ETX][BCC]
	if ( nRemainderBytes > MAX_MSG_LENGTH - 4)
		return F3_E_MESSAGE_TOO_LONG;

	m_dwMsgLen = nRemainderBytes + 4;
	if ( m_dwMsgLen < 11 )	// СӦϢΪ11
		return F3_E_COMM_ERROR;

	// У
	BYTE bcc = GetBCC(m_bMsgBuff, m_dwMsgLen);
	if (m_bMsgBuff[m_dwMsgLen - 1] != bcc)
		return F3_E_COMM_ERROR;
	return 0;
}


BYTE 
CCommServiceF3::GetBCC(
                    IN LPBYTE pbBuff,
                    IN DWORD dwLength
                    )
{
	BYTE bcc = 0;
	for (USHORT i = 0; i < dwLength - 1; i++)
		bcc ^= pbBuff[i];
	return bcc;

}

//////Encyrpt&Decrpyt////////// encrypt

long CCommServiceF3::EncryptExecute(IN BYTE bCMDByte1,IN BYTE bCMDByte2,IN PBYTE pbCMPBuff,IN USHORT cbCMPLength,__in_opt PBYTE pbRDTBuff,__in_opt  PDWORD pcbRDTLength)
{

	LONG lRet;
	BOOL fNeg;
	CAutoLock lock(&m_cs);
	lRet = m_pPort->ResetInput();
	if (lRet != 0) return lRet;

	EncryptMakeCommand(bCMDByte1, bCMDByte2, pbCMPBuff, cbCMPLength);

	lRet = SendCommand();
	if (lRet != 0) return lRet;

	lRet = RecvACK(&fNeg);
	if (lRet != 0) return lRet;

	// ENQ
	BYTE b = 0x05;
	m_pPort->WriteData(&b, 1);
	if (lRet != 0) return lRet;

	lRet = EncrypRecvResponse();
	if (lRet != 0) return lRet;

    lRet = HandleResponse(pbRDTBuff,pcbRDTLength);

	return lRet ;

}


LONG CCommServiceF3::EncryptMakeCommand(BYTE bCmdCode1, BYTE bCmdCode2, LPBYTE pbCmdData, USHORT usCmdLen)
{
	DWORD dwLen = 7;
	if (pbCmdData != NULL
		&& usCmdLen > 0)
		dwLen += usCmdLen;

	if (dwLen > MAX_MSG_LENGTH)
		return F3_E_COMM_ERROR;

	m_dwMsgLen = 0;
	m_bMsgBuff[m_dwMsgLen++] = 0x02;
	m_bMsgBuff[m_dwMsgLen++] = (BYTE) HIBYTE(usCmdLen + 2);
	m_bMsgBuff[m_dwMsgLen++] = (BYTE) LOBYTE(usCmdLen + 2);
	m_bMsgBuff[m_dwMsgLen++] = bCmdCode1;
	m_bMsgBuff[m_dwMsgLen++] = bCmdCode2;

	if (dwLen > 7)
	{
		memcpy(&m_bMsgBuff[m_dwMsgLen], pbCmdData, usCmdLen);
		m_dwMsgLen += usCmdLen;
	}

	m_bMsgBuff[m_dwMsgLen++] = 0x03;
	m_bMsgBuff[m_dwMsgLen] = GetBCC(m_bMsgBuff, m_dwMsgLen+1);
	m_dwMsgLen++;

	return 0;
}


LONG CCommServiceF3::EncrypRecvResponse()
{
	LONG lRet;
	DWORD BytesRead;
	//
	//  [STX][SELEN]3ֽڡ
	//
	lRet = m_pPort->ReadData(m_bMsgBuff, 1024, &BytesRead);
	//lRet = ReadData(m_bMsgBuff,1024);
	if (lRet < 0)  return lRet;

	CString str,strtemp;
	strtemp = m_bMsgBuff;
	str.Format(_T("ReadData2 = %d "),lRet);
	//MessageBox(NULL,str,0,0);
	//
	// ӦϢĳȡ
	//
	m_dwMsgLen = ((m_bMsgBuff[1] << 8) | m_bMsgBuff[2]) + 2 + 3;

	//
	// ӦϢĳǷ񳬹ڲĴС
	//
	if (m_dwMsgLen > MAX_MSG_LENGTH)
		return F3_E_COMM_ERROR;

	//
	// ӦϢδȡǲݡ
	//
	//
	// ӦϢСǷΪ 8 ֽڡ
	//
	if (m_dwMsgLen < 8)
		return F3_E_COMM_ERROR;

	if (m_bMsgBuff[m_dwMsgLen - 1]
		!= GetBCC(m_bMsgBuff, m_dwMsgLen))
		return F3_E_COMM_ERROR;

	return 0;
}


LONG CCommServiceF3::HandleResponse(LPBYTE pbRespData, LPDWORD pdwRespLen)
{
	if (m_bMsgBuff[3] == 'P')
	{
		DWORD RDTLen = m_dwMsgLen - 8;
		if (pbRespData != NULL
			&& pdwRespLen != NULL)
		{
			if (*pdwRespLen < RDTLen )
				return F3_E_BUFFER_TOO_SMALL;
			*pdwRespLen = RDTLen;
			memcpy(pbRespData, &m_bMsgBuff[6], RDTLen);
		}
		return 0;
	}
	else if (m_bMsgBuff[3] == 'N')
	{
		return F3_E_COMMAND_FAILURE;
	}
	else
	{
		return F3_E_COMM_ERROR;
	}
}







