#pragma once


#include "logger.h"
#include "ports.h"
#include "F3api.h"

//#define MAX_MSGSIZE	1024
#define MIN_MSGSIZE	8
#define MAX_TEXTSIZE	(MAX_MSGSIZE - MIN_MSGSIZE)

class CCommServiceF3
{
public:
    CCommServiceF3();
    ~CCommServiceF3();

    long Connect(
                __in DWORD  dwPortNumber,
                __in DWORD  dwBps,
				IN BYTE bAddress,
                __in_opt LPCSTR pszLogDir
                );

    void Disconnect();


	/*long Execute(			   __in LPBYTE pbCmdData, 
							   __in USHORT usCmdLen,
							   __in_opt DWORD dwReqLength,
							   __in_opt LPBYTE pbRespData,
							   __in_opt LPDWORD pdwRespLen);*/


	long Execute(
		IN BYTE bCMDByte1,
		IN BYTE bCMDByte2,
		IN PBYTE pbCMPBuff,
		IN USHORT cbCMPLength,
		__in_opt PBYTE pbRDTBuff,
		__in_opt  PDWORD pcbRDTLength,
		OUT PCRSTATUS pStatus);

	LONG ExecApduCommand(BYTE bCMDByte1, BYTE bCMDByte2, BYTE bCLA, BYTE bINS, BYTE bP1, BYTE bP2, BYTE bLength, PBYTE pbSendData, PBYTE pbRecvData, PDWORD pcbRecvLength);

	long EncryptExecute(BYTE bCMDByte1,BYTE bCMDByte2,PBYTE pbCMPBuff,USHORT cbCMPLength,PBYTE pbRDTBuff,PDWORD pcbRDTLength);
private:
	/*long MakeMessage(
		__in LPBYTE pbData,
		__in DWORD dwLength
		);*/


  long	MakeMessage(
	  __in BYTE bCMDByte1, 
	  __in BYTE bCMDByte2,
	  __in PBYTE pbCMPBuff, 
	  __in USHORT cbCMPLength
	  );

  LONG	MakeMessage(BYTE bCMDByte1, BYTE bCMDByte2, BYTE bCLA, BYTE bINS, BYTE bP1, BYTE bP2, BYTE bLength, PBYTE pbSendData);
  LONG  EncryptMakeCommand(BYTE bCmdCode1, BYTE bCmdCode2, LPBYTE pbCmdData, USHORT usCmdLen);

    long SendCommand();
	long SendACK();
	LONG TranControl();

	//LONG HandleResponse(LPBYTE pbRespData, LPDWORD pdwRespLen);

	/*LONG 
	RecvResponse(
		__in_opt DWORD dwReqLength,
		__in_opt LPBYTE pbRecvBuff,
		__in_opt LPDWORD pdwRecvLength
		);*/

    long RecvACK(LPBOOL pfNeg);

    //long SendENQ();
	LONG  WaitForResponse();
    long RecvResponse();
    BYTE GetBCC(LPBYTE pbBuff, DWORD dwLength);
	LONG ProcessResponseData(BOOL bHasSW, PBYTE pbRecvData, PDWORD pcbRecvLength, PCRSTATUS pStatus);
	LONG EncrypRecvResponse();
	LONG HandleResponse(LPBYTE pbRespData, LPDWORD pdwRespLen);
private:
    CRITICAL_SECTION m_cs;
    //BYTE m_bMsgBuff[MAX_MSGSIZE];
	//DWORD m_dwMsgLength;
    CPortBase *m_pPort;
    CLogger m_logg;

	enum { MAX_MSG_LENGTH = 1024 };
	OVERLAPPED m_oRead;
	OVERLAPPED m_oWrite;
	HANDLE m_hDevice;
	BYTE m_bMsgBuff[MAX_MSG_LENGTH];
	DWORD m_dwMsgLen;


	HANDLE m_hEvtCanceling;
	HANDLE m_hEvtCanceled;
	BOOL m_fConnected;
	BOOL m_fTakein;
	BOOL m_fCancelable;
	BOOL m_fInProgress;
	BYTE	m_Address;

	BOOL  m_usbConnect;
};