#pragma once

#include "logger.h"

class CPortBase
{
public:
    CPortBase();
    virtual ~CPortBase();

    int Initialize(char *pDevPath, DWORD dwBps,CLogger *pLogger);
    void Release();

    virtual int ReadData(LPBYTE pbBuff, DWORD dwBytesToRead, LPDWORD pdwBytesRead) = 0;
    virtual int WriteData(LPBYTE pbBuff, DWORD dwBytesToWrite) = 0;
    virtual int WaitDataAvailable(DWORD dwTimeOut) = 0;
    virtual int ResetInput() = 0;

protected:
    virtual int InitPort(char *pDevPath,DWORD dwBps) = 0;
    void ReleasePort();

    int InitEvents();
    void ReleaseEvents();

protected:
    HANDLE m_hFile;
    OVERLAPPED m_oRead;
    OVERLAPPED m_oWrite;
    CLogger *m_pLogger;
};


#define PURGE_FLAG  \
		( PURGE_TXABORT \
			| PURGE_RXABORT \
			| PURGE_TXCLEAR \
			| PURGE_RXCLEAR )
			


class CSerialPort : public CPortBase
{
public:
    CSerialPort();
    ~CSerialPort();

    int ReadData(LPBYTE pbBuff, DWORD dwBytesToRead, LPDWORD pdwBytesRead);
    int WriteData(LPBYTE pbBuff, DWORD dwBytesToWrite);
    int WaitDataAvailable(DWORD dwTimeOut);
    int ResetInput();

protected:
    int InitPort(char *pDevPath,DWORD dwBps);
};



class CUsbPort : public CPortBase
{
public:
    CUsbPort();
    ~CUsbPort();


    WCHAR *Currhid_DevPath;
    

    int ReadData(LPBYTE pbBuff, DWORD dwBytesToRead, LPDWORD pdwBytesRead);
    int WriteData(LPBYTE pbBuff, DWORD dwBytesToWrite);
    int WaitDataAvailable(DWORD dwTimeOut) ;
    int ResetInput();

protected:
    int InitPort(char *pDevPath,DWORD dwBps);

protected:
    PBYTE m_pbInRptBuff;
    UINT m_nInRptLen;
    PBYTE m_pbOutRptBuff;
    UINT m_nOutRptLen;
};