// DispTestPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "DispTestPanel.h"

#define THD_ABORTED	(WM_USER + 10)
#define WM_COUNTERCHANGED	(WM_USER + 11)

enum TESTSTATE
{
     WM_TAKECARDNI,
	 WN_NO_COUNT,
	 WN_COUNT,
	 WN_TAKE_CARD
};

// CDispTestPanel Ի

IMPLEMENT_DYNAMIC(CDispTestPanel, CPanelBase)

	
BYTE CDispTestPanel::Data0 = 2;
BYTE CDispTestPanel::Data1 = 2;
BYTE CDispTestPanel::Data2 = 10;
BYTE CDispTestPanel::Data3 = 10;


CDispTestPanel::CDispTestPanel(CWnd* pParent /*=NULL*/)
	: CPanelBase(CDispTestPanel::IDD, pParent)
{
	m_pThread = NULL;
	m_hStopEvent = NULL;

	m_nDispenseNum = 0;
	m_nCaptureNum = 0;
	m_nEjectNum = 0;
}

CDispTestPanel::~CDispTestPanel()
{
	StopTest();
}

void CDispTestPanel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_AGINGTEST_LIST, m_AgingTestList);
	DDX_Control(pDX, IDC_AGINGTEST_INTERVAL, m_AgingTestInterval);
	DDX_Control(pDX, IDC_LED1_INTERVAL_BOX, m_LED1_IntervalBox);
	DDX_Control(pDX, IDC_LED2_INTERVAL_BOX, m_LED2_IntervalBox);
	DDX_Control(pDX, IDC_LED1_TIME_BOX, m_LED1_TimeBox);
	DDX_Control(pDX, IDC_LED2_TIME_BOX, m_LED2_TimeBox);
}


BEGIN_MESSAGE_MAP(CDispTestPanel, CPanelBase)
	ON_BN_CLICKED(IDC_DT_START_TEST, &CDispTestPanel::OnBnClickedDtStartTest)
	ON_BN_CLICKED(IDC_DT_STOP_TEST, &CDispTestPanel::OnBnClickedDtStopTest)
	ON_CBN_SELCHANGE(IDC_DT_POSITIONS, &CDispTestPanel::OnCbnSelchangeDtPositions)
	ON_CBN_SELCHANGE(IDC_DT_ACTIONS, &CDispTestPanel::OnCbnSelchangeDtActions)
	ON_BN_CLICKED(IDC_DT_CLEAR, &CDispTestPanel::OnBnClickedDtClear)
	ON_MESSAGE(THD_ABORTED, &CDispTestPanel::OnThreadAborted)
	ON_MESSAGE(WM_COUNTERCHANGED, &CDispTestPanel::OnCounterChanged)
	ON_WM_ENABLE()
	ON_BN_CLICKED(IDC_START_ARGINGTEST, &CDispTestPanel::OnBnClickedStartArgingtest)
	ON_BN_CLICKED(IDC_STOP_ARGINGTEST, &CDispTestPanel::OnBnClickedStopArgingtest)
	ON_BN_CLICKED(IDC_LED1_INVALID, &CDispTestPanel::OnBnClickedLed1Invalid)
	ON_BN_CLICKED(IDC_LED2_INVALID, &CDispTestPanel::OnBnClickedLed2Invalid)
	ON_BN_CLICKED(IDC_LED1_OFF, &CDispTestPanel::OnBnClickedLed1Off)
	ON_BN_CLICKED(IDC_LED2_OFF, &CDispTestPanel::OnBnClickedLed2Off)
	ON_BN_CLICKED(IDC_LED1_ON, &CDispTestPanel::OnBnClickedLed1On)
	ON_BN_CLICKED(IDC_LED2_ON, &CDispTestPanel::OnBnClickedLed2On)
	ON_BN_CLICKED(IDC_LED1_BLINK, &CDispTestPanel::OnBnClickedLed1Blink)
	ON_BN_CLICKED(IDC_LED2_BLINK, &CDispTestPanel::OnBnClickedLed2Blink)
	ON_BN_CLICKED(IDC_DT_CLEAR2, &CDispTestPanel::OnBnClickedDtClear2)
END_MESSAGE_MAP()


void CDispTestPanel::StopTest()
{
	if (m_pThread != NULL
		&& m_hStopEvent != NULL)
	{

		SetEvent(m_hStopEvent);
		WaitForSingleObject(m_pThread->m_hThread, INFINITE);
	}
}

// CDispTestPanel Ϣ


BOOL CDispTestPanel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	CComboBox *pList;
	int idx;
	CString strTitle;

	pList = GetComboBox(IDC_DT_POSITIONS);
	LoadString(IDS_GATE_POS, strTitle);
	idx = pList->AddString(strTitle);
	pList->SetItemData(idx, MM_RETURN_TO_FRONT);

	LoadString(IDS_ICC_POS, strTitle);
	idx = pList->AddString(strTitle);
	pList->SetItemData(idx, MM_RETURN_TO_IC_POS);

	LoadString(IDS_RFC_POS, strTitle);
	idx = pList->AddString(strTitle);
	pList->SetItemData(idx, MM_RETURN_TO_RF_POS);
	pList->SetCurSel(1);
	m_bMoveMode = MM_RETURN_TO_IC_POS;

	pList->SetItemData(pList->AddString(_T("Front Insertion")), MM_EJECT_FROM_FRONT);

	LoadString(IDS_CAPTURE, strTitle);
	pList = GetComboBox(IDC_DT_ACTIONS);
	idx = pList->AddString(strTitle);
	pList->SetItemData(idx, A_CAPTURE);

	LoadString(IDS_EJECT_TO_FRONT, strTitle);
	idx = pList->AddString(strTitle);
	pList->SetItemData(idx, A_EJECT);
	pList->SetCurSel(0);
	m_fCapture = true;


	CString str;
	str = _T("Eject");
	m_AgingTestList.AddString( str );
	str = _T("Capture");
	m_AgingTestList.AddString( str);
	m_AgingTestList.SetCurSel(0);

	this->m_AgingTestInterval.SetRange(1, 255);
	this->m_AgingTestInterval.SetValue(2);


	m_LED1_IntervalBox.SetRange(0, 63);
	m_LED1_IntervalBox.SetLimitText( 3 );
	m_LED1_TimeBox.SetRange(0, 255);
	m_LED1_TimeBox.SetLimitText( 3 );

	m_LED2_IntervalBox.SetRange(0, 63);
	m_LED2_IntervalBox.SetLimitText( 3 );
	m_LED2_TimeBox.SetRange(0, 255);
	m_LED2_TimeBox.SetLimitText( 3 );

	m_LED1_IntervalBox.SetValue( Data0 & 0x3f );
	m_LED2_IntervalBox.SetValue( Data1 & 0x3f );


	m_LED1_TimeBox.SetValue( Data2 );
	m_LED2_TimeBox.SetValue( Data3 );
	

	switch ( Data0 >> 6 )
	{
	case 0:
		GetButton(IDC_LED1_OFF)->SetCheck( TRUE );
		break;
	case 1:
		GetButton(IDC_LED1_ON)->SetCheck( TRUE );
		break;
	case 2:
		GetButton(IDC_LED1_BLINK)->SetCheck( TRUE );
		break;
	case 3:
		GetButton(IDC_LED1_INVALID)->SetCheck( TRUE );
		break;
	}

	switch ( Data1 >> 6 )
	{
	case 0:
		GetButton(IDC_LED2_OFF)->SetCheck( TRUE );
		break;
	case 1:
		GetButton(IDC_LED2_ON)->SetCheck( TRUE );
		break;
	case 2:
		GetButton(IDC_LED2_BLINK)->SetCheck( TRUE );
		break;
	case 3:
		GetButton(IDC_LED2_INVALID)->SetCheck( TRUE );
		break;
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CDispTestPanel::OnBnClickedDtStartTest()
{
	OnBnClickedDtClear();
	CComboBox *pList= GetComboBox(IDC_DT_POSITIONS);
	m_bMoveMode = (BYTE) pList->GetItemData(pList->GetCurSel());

	g_pOutWnd->SetFocus();
	m_pThread = AfxBeginThread(&TestThread,
		this, THREAD_PRIORITY_NORMAL, CREATE_SUSPENDED, NULL);
	if (m_pThread != NULL)
	{
		m_pThread->m_bAutoDelete = FALSE;
		m_hStopEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
		m_pThread->ResumeThread();

		UpdateUIState(TRUE);
	}
	else
	{
		AfxMessageBox(_T("߳ʧ!"), MB_OK | MB_ICONERROR);
	}
}


void CDispTestPanel::OnBnClickedDtStopTest()
{
	StopTest();
}


void CDispTestPanel::OnBnClickedDtClear()
{
	SetDlgItemInt(IDC_DT_DISPENSE_NUM_BOX, m_nDispenseNum = 0);
	SetDlgItemInt(IDC_DT_CAPTURE_NUM_BOX, m_nCaptureNum = 0);
	SetDlgItemInt(IDC_DT_EJECT_NUM_BOX, m_nEjectNum = 0);
}

void CDispTestPanel::OnCbnSelchangeDtPositions()
{
	CComboBox *pList= GetComboBox(IDC_DT_POSITIONS);
	m_bMoveMode = (BYTE) pList->GetItemData(pList->GetCurSel());

	int idx;
	CString strTitle;

	LoadString(IDS_CAPTURE, strTitle);
	pList = GetComboBox(IDC_DT_ACTIONS);

	UpdateData(TRUE);
	for (int i = 0; i < 2; i ++)
	pList->DeleteString(0);
	
	/*CString  strMsg;
	strMsg.Format(_T("m_bMoveMode = %x ncount = %d "), m_bMoveMode,pList->GetCount());
	MessageBox(strMsg);*/

	if(m_bMoveMode == 0x01)
	{
		
		idx = pList->AddString(strTitle);
		pList->SetItemData(idx, A_CAPTURE);	
	}
	else
	{
		idx = pList->AddString(strTitle);
		pList->SetItemData(idx, A_CAPTURE);

		LoadString(IDS_EJECT_TO_FRONT, strTitle);
		idx = pList->AddString(strTitle);
		pList->SetItemData(idx, A_EJECT);
		
	}
	pList->SetCurSel(0);
		ClearOutput();
}


void CDispTestPanel::OnCbnSelchangeDtActions()
{
	CComboBox *pList= GetComboBox(IDC_DT_ACTIONS);
	ACTION a = (ACTION) pList->GetItemData(pList->GetCurSel());
	m_fCapture = a == A_CAPTURE;
}


LRESULT CDispTestPanel::OnThreadAborted(WPARAM wParam, LPARAM lParam)
{
	delete m_pThread;
	m_pThread = NULL;

	CloseHandle(m_hStopEvent);
	m_hStopEvent = NULL;

	UpdateUIState(FALSE);

	return 0;
}


LRESULT CDispTestPanel::OnCounterChanged(WPARAM wParam, LPARAM lParam)
{
	CString strMsg;

	//strMsg.Format(_T("m_bMoveMode = %x wParam = %d"),m_bMoveMode,wParam);
	//MessageBox(strMsg);
	
	if (  (TESTSTATE)wParam == WN_TAKE_CARD)
	{
		strMsg = _T("ȡ߿Ƭ...\r\n");
		OutputMessage(strMsg);
	}

	if(m_bMoveMode == 0x01)
	{
		if (  (TESTSTATE)wParam == 1)
		{
			//strMsg = _T("ǰ˲忨...\r\n");
			//OutputMessage(strMsg);
		}else if( (TESTSTATE)wParam == 2)
		{
			//SetDlgItemInt(IDC_DT_DISPENSE_NUM_BOX, m_nDispenseNum);
			SetDlgItemInt(IDC_DT_CAPTURE_NUM_BOX, m_nCaptureNum);
			//SetDlgItemInt(IDC_DT_EJECT_NUM_BOX, m_nEjectNum);
		}	
	}else 
	{
		if ((TESTSTATE)wParam == 0)
		{
		SetDlgItemInt(IDC_DT_DISPENSE_NUM_BOX, m_nDispenseNum);
		SetDlgItemInt(IDC_DT_CAPTURE_NUM_BOX, m_nCaptureNum);
		SetDlgItemInt(IDC_DT_EJECT_NUM_BOX, m_nEjectNum);
	
		}
	}



	return 0;
}

UINT CDispTestPanel::TestThread(LPVOID pvParam)
{
	CDispTestPanel* pDlg = (CDispTestPanel*) pvParam;
	LONG lResult = 0;
	BYTE bStatus[NUM_SENSORS];
	CRSTATUS crs;
	BOOL bStart = TRUE;

	if(pDlg->m_bMoveMode == 0x01)
	{
		lResult = F3_PermitInsertion(g_hReader);
		OutputResult(lResult, _T("ǰ˽"), NULL);
		pDlg->m_fCapture = TRUE;
	}

	CString str;
	while (true)
	{
CHECK:
		if (WaitForSingleObject(pDlg->m_hStopEvent, 20) == WAIT_OBJECT_0)
			break;

		lResult = F3_GetCRStatus(g_hReader, &crs);
		if (lResult != 0) break;

	
		if(crs.bLaneStatus != LS_NO_CARD_IN){
			if(bStart){
			::PostMessage(pDlg->GetSafeHwnd(), WM_COUNTERCHANGED, (WPARAM)WN_TAKE_CARD, NULL);
			bStart = FALSE;
			}
			goto CHECK;
		}
		bStart = TRUE;

		if(pDlg->m_bMoveMode != 0x01)
		{

		
			lResult = F3_MoveCard(g_hReader, pDlg->m_bMoveMode);
			OutputResult(lResult, _T("Dispense OK!"), NULL);
			if (lResult != 0){
				break;
			}
		}

		Sleep(800);
		pDlg->m_nDispenseNum++;
		::PostMessage(pDlg->GetSafeHwnd(), WM_COUNTERCHANGED, (WPARAM)WM_TAKECARDNI, NULL);

		if (pDlg->m_fCapture)
		{

			lResult = F3_GetSenserDetail(g_hReader, bStatus);
			if(bStatus[0] == 0x31 || bStatus[2] == 0x31 ||bStatus[3] == 0x31 || bStatus[1] == 0x31 )
			{
				lResult = F3_MoveCard(g_hReader, MM_CAPTURE_TO_BOX);
				if (lResult != 0) break;
				OutputResult(lResult, _T("Capture"), NULL);

				pDlg->m_nCaptureNum++;
				::PostMessage(pDlg->GetSafeHwnd(), WM_COUNTERCHANGED, (WPARAM)WN_COUNT, NULL);
			}else

				::PostMessage(pDlg->GetSafeHwnd(), WM_COUNTERCHANGED, (WPARAM) WN_NO_COUNT, NULL);
		}
		else if(pDlg->m_bMoveMode != 0x01)
		{
			//str.Format(_T("%02x"),pDlg->m_bMoveMode );
			//::MessageBox(NULL,str,0,0);
			lResult = F3_MoveCard(g_hReader, MM_EJECT_TO_FRONT);
			OutputResult(lResult, _T("Eject"), NULL);
			if (lResult != 0)
				break;

			pDlg->m_nEjectNum++;
			::PostMessage(pDlg->GetSafeHwnd(), WM_COUNTERCHANGED, (WPARAM)WM_TAKECARDNI, NULL);
		}
	}

	if (lResult != 0)
	{
		CString strMsg;
		GetResultMessage(lResult, strMsg);

		UINT uType = MB_OK | MB_ICONERROR | MB_TOPMOST;
		if (lResult == F3_E_CARD_BOX_EMPTY
			|| lResult == F3_E_CAPTURE_BOX_FULL)
			uType |= MB_ICONWARNING;

		::MessageBox(NULL, strMsg, afxCurrentAppName, uType);
	}
	if(pDlg->m_bMoveMode == 0x01)
	{
		F3_DenieInsertion(g_hReader);
	}

	::PostMessage(pDlg->GetSafeHwnd(), THD_ABORTED, NULL, NULL);

	return 0;
}


void CDispTestPanel::UpdateUIState(BOOL bTesting)
{
	GetDlgItem(IDC_DT_POSITIONS)->EnableWindow(! bTesting);
	GetDlgItem(IDC_DT_ACTIONS)->EnableWindow(! bTesting);
	GetDlgItem(IDC_DT_START_TEST)->EnableWindow(! bTesting);
	GetDlgItem(IDC_DT_STOP_TEST)->EnableWindow(bTesting);
	GetDlgItem(IDC_DT_CLEAR)->EnableWindow(! bTesting);
}


void CDispTestPanel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	GetDlgItem(IDC_DT_START_TEST)->EnableWindow(bEnable);
	GetDlgItem(IDC_DT_STOP_TEST)->EnableWindow(bEnable);
	GetDlgItem(IDC_DT_POSITIONS)->EnableWindow(bEnable);
	GetDlgItem(IDC_DT_ACTIONS)->EnableWindow(bEnable);
	GetDlgItem(IDC_DT_CLEAR)->EnableWindow(bEnable);
}


void CDispTestPanel::OnBnClickedStartArgingtest()
{
	// TODO: ڴӿؼ֪ͨ
	if ( !m_AgingTestInterval.IsValidInput() )
		return;

	BYTE mode = m_AgingTestList.GetCurSel();
	BYTE interval = (BYTE) m_AgingTestInterval.GetValue();
	LONG lResult = F3_EnableAgingTest(g_hReader, mode, interval);
	if (lResult != 0)
	{
		CString strMsg;
		GetResultMessage(lResult, strMsg);
		AfxMessageBox( strMsg, MB_OK | MB_ICONERROR );
	}
}


void CDispTestPanel::OnBnClickedStopArgingtest()
{
	// TODO: ڴӿؼ֪ͨ
	LONG lResult = F3_DisableAgingTest(g_hReader);
	if (lResult != 0)
	{
		CString strMsg;
		GetResultMessage(lResult, strMsg);
		AfxMessageBox( strMsg, MB_OK | MB_ICONERROR );
	}

	OutputResult(lResult, GetFocus(), NULL);
}


void CDispTestPanel::OnBnClickedLed1Invalid()
{
	// TODO: ڴӿؼ֪ͨ
		Data0 = 3;
}


void CDispTestPanel::OnBnClickedLed2Invalid()
{
	// TODO: ڴӿؼ֪ͨ
	Data1 = 3;
}


void CDispTestPanel::OnBnClickedLed1Off()
{
	// TODO: ڴӿؼ֪ͨ
	Data0 = 0;
}


void CDispTestPanel::OnBnClickedLed2Off()
{
	// TODO: ڴӿؼ֪ͨ
	Data1 = 0;
}


void CDispTestPanel::OnBnClickedLed1On()
{
	// TODO: ڴӿؼ֪ͨ
	Data0 = 1;
}


void CDispTestPanel::OnBnClickedLed2On()
{
	// TODO: ڴӿؼ֪ͨ
	Data1 = 1;
}


void CDispTestPanel::OnBnClickedLed1Blink()
{
	// TODO: ڴӿؼ֪ͨ
	Data0 = 2;
}


void CDispTestPanel::OnBnClickedLed2Blink()
{
	// TODO: ڴӿؼ֪ͨ
	Data1 = 2;
}


void CDispTestPanel::OnBnClickedDtClear2()
{
	// TODO: ڴӿؼ֪ͨ
	BYTE abPare[4];

	if ( !m_LED1_IntervalBox.IsValidInput() )
		return;
	if ( !m_LED1_TimeBox.IsValidInput() )
		return;
	if ( !m_LED2_IntervalBox.IsValidInput() )
		return;
	if ( !m_LED2_TimeBox.IsValidInput())
		return;
	BYTE bPare[4];

    abPare[0] = (Data0 << 6 );
	abPare[0] |= ( m_LED1_IntervalBox.GetValue() & 0x3f );

	abPare[1] = (Data1 << 6 );
	abPare[1] |= ( m_LED2_IntervalBox.GetValue() & 0x3f );
	
	
	abPare[2] = m_LED1_TimeBox.GetValue();
	abPare[3] = m_LED2_TimeBox.GetValue();


	//F3_LedOutCtl()
	LONG lResult = F3_LedOutCtl( g_hReader, abPare);
	OutputResult(lResult, GetFocus(), NULL);
}
