// IccPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "IccWorkspace.h"


// CIccWorkspace Ի

IMPLEMENT_DYNAMIC(CIccWorkspace, CPanelBase)

CIccWorkspace::CIccWorkspace(CWnd* pParent /*=NULL*/)
	: CPanelBase(CIccWorkspace::IDD, pParent)
{

}

CIccWorkspace::~CIccWorkspace()
{
}

void CIccWorkspace::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ICC_TAB, m_tab);
}


BEGIN_MESSAGE_MAP(CIccWorkspace, CPanelBase)
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_ENABLE()
END_MESSAGE_MAP()


// CIccWorkspace Ϣ


BOOL CIccWorkspace::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	CString strTitle;
	LoadString(IDS_CPU_CARD, strTitle);
	m_tab.AddPage(strTitle, &m_CpuWnd);
	LoadString(IDS_SAM_CARD, strTitle);
	m_tab.AddPage(strTitle, &m_SamWnd);
	m_tab.AddPage(_T("SLE4442"), &m_Sle4442Wnd);
	m_tab.AddPage(_T("SLE4428"), &m_Sle4428Wnd);
	m_tab.AddPage(_T("AT24Cxx"), &m_I2cWnd);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CIccWorkspace::OnSize(UINT nType, int cx, int cy)
{
	CPanelBase::OnSize(nType, cx, cy);

	if (m_tab)
	{
		RECT rect;
		GetClientRect(&rect);
		m_tab.MoveWindow(&rect);
	}
}


int CIccWorkspace::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CPanelBase::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (! m_CpuWnd.Create(this))
		return -1;

	if (! m_SamWnd.Create(this))
		return -1;

	if (! m_Sle4442Wnd.Create(this))
		return -1;

	if (! m_Sle4428Wnd.Create(this))
		return -1;

	if (! m_I2cWnd.Create(this))
		return -1;

	return 0;
}

void CIccWorkspace::Select(BYTE bCardType)
{
	switch (bCardType)
	{
	case ICCTYPE_TO_CPU: 
	case ICCTYPE_T1_CPU: 
		m_tab.SelectPage(&m_CpuWnd);
		break;
	case ICCTYPE_SLE4442:
		m_tab.SelectPage(&m_Sle4442Wnd);
		break;
	case ICCTYPE_SLE4428:
		m_tab.SelectPage(&m_Sle4428Wnd);
		break;
	case ICCTYPE_AT24C01:
	case ICCTYPE_AT24C02:
	case ICCTYPE_AT24C04:
	case ICCTYPE_AT24C08:
	case ICCTYPE_AT24C16:
	case ICCTYPE_AT24C32:
	case ICCTYPE_AT24C64:
	case ICCTYPE_AT24C128:
	case ICCTYPE_AT24C256:
		m_tab.SelectPage(&m_I2cWnd);
	}
}

void CIccWorkspace::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	m_CpuWnd.EnableWindow(bEnable);
	m_SamWnd.EnableWindow(bEnable);
	m_Sle4442Wnd.EnableWindow(bEnable);
	m_Sle4428Wnd.EnableWindow(bEnable);
	m_I2cWnd.EnableWindow(bEnable);
}
