// IsoPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "IsoPanel.h"
#include "afxdialogex.h"


// CIsoPanel Ի

IMPLEMENT_DYNAMIC(CIsoPanel, CPanelBase)

CIsoPanel::CIsoPanel(CWnd* pParent /*=NULL*/)
	: CPanelBase(CIsoPanel::IDD, pParent)
{

}

CIsoPanel::~CIsoPanel()
{
}

void CIsoPanel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BLOCKS, m_cbbBlock);
	DDX_Control(pDX, IDC_ADDRESS_BLOCK, m_cbbAddress);
	DDX_Control(pDX, IDC_SXX_DATA_GRID, m_DataGrid);
	DDX_Control(pDX, IDC_SXX_DIFID_GRID2, m_DifidGrid);
}


BEGIN_MESSAGE_MAP(CIsoPanel, CPanelBase)
	ON_BN_CLICKED(IDC_WRITE_BLOCK, &CIsoPanel::OnBnClickedWriteBlock)
	ON_BN_CLICKED(IDC_READ_BLOCK, &CIsoPanel::OnBnClickedReadBlock)
	ON_BN_CLICKED(IDC_LOCK_BLOCK, &CIsoPanel::OnBnClickedLockBlock)
	ON_BN_CLICKED(IDC_BUTTON5, &CIsoPanel::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BLOCK_AFI, &CIsoPanel::OnBnClickedBlockAfi)
END_MESSAGE_MAP()


// CIsoPanel Ϣ


void CIsoPanel::OnBnClickedWriteBlock()
{
	// TODO: ڴӿؼ֪ͨ

	if (! m_DataGrid.ValidateInput())
		return;

	int nBlock = m_cbbBlock.GetItemData(m_cbbBlock.GetCurSel());
	int addr = m_cbbAddress.GetItemData(m_cbbAddress.GetCurSel());

	BYTE DataBytes[4];
	m_DataGrid.GetContent(DataBytes, sizeof(DataBytes));
	LONG lRet = F3_ISO15693_WriteSingleBlock(g_hReader,nBlock,addr,DataBytes);
	OutputResult(lRet, GetFocus(), NULL);
}


BOOL CIsoPanel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	// TODO:  ڴӶĳʼ
	InitComBo();
	m_DataGrid.Init(1, 4, 0, 0);
	BYTE PwdBytes[] = { 0xff, 0xff, 0xff, 0xff};
	m_DataGrid.Fill(PwdBytes, sizeof(PwdBytes));

	m_DifidGrid.Init(1, 1, 0, 0);
	m_DifidGrid.Fill(PwdBytes, sizeof(PwdBytes));
	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CIsoPanel:: InitComBo()
{
	CString strMsg;
	strMsg.Format(_T("%d"),1);
	 m_cbbBlock.SetItemData(m_cbbBlock.AddString(strMsg),1);
	for (int i = 0; i < 256;  i++)
	{
		 strMsg.Format(_T("%d"),i);
		 m_cbbAddress.SetItemData(m_cbbAddress.AddString(strMsg),i);
		
	}
	m_cbbBlock.SetCurSel(0);
	m_cbbAddress.SetCurSel(0);
}


void CIsoPanel::OnBnClickedReadBlock()
{
	// TODO: ڴӿؼ֪ͨ
	int nBlock = m_cbbBlock.GetItemData(m_cbbBlock.GetCurSel());
	int addr = m_cbbAddress.GetItemData(m_cbbAddress.GetCurSel());

	BYTE bRBuff[256];
	DWORD dReLength = sizeof(bRBuff);
	CString strInfo,strMsg;

	LONG lRet = F3_ISO15693_ReadSingleBlock(g_hReader,nBlock,addr,bRBuff,&dReLength);
	if(lRet == 0){
		for (int i = 0; i < dReLength; i++ )
		{
			 strInfo.Format(_T("%02x "),bRBuff[i]);
			 strMsg += strInfo;
		}
		m_DataGrid.ResetContent();
		m_DataGrid.Fill(bRBuff, dReLength);

	}

	OutputResult(lRet, GetFocus(), strMsg);
}


void CIsoPanel::OnBnClickedLockBlock()
{
	// TODO: ڴӿؼ֪ͨ


	LONG lRet = 	F3_ISO15693_LockBlock(g_hReader);
	OutputResult(lRet, GetFocus(), NULL );


}


void CIsoPanel::OnBnClickedButton5()
{
	// TODO: ڴӿؼ֪ͨ

	if (! m_DifidGrid.ValidateInput())
		return;
	BYTE DataBytes[1];
	m_DifidGrid.GetContent(DataBytes, sizeof(DataBytes));
	LONG lRet = F3_ISO15693_WriteDSFID(g_hReader,DataBytes[1]);
	OutputResult(lRet, GetFocus(), NULL);

}


void CIsoPanel::OnBnClickedBlockAfi()
{
	// TODO: ڴӿؼ֪ͨ
	LONG lRet = 	F3_ISO15693_LockDSFID(g_hReader);
	OutputResult(lRet, GetFocus(), NULL );
}
