// SensorDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "SensorDlg.h"
#include "afxdialogex.h"


#define CLR_ERROR       RGB(255, 0, 0)
#define CLR_INFO        RGB(0, 0, 128)
// CSensorDlg Ի
#define WM_UPDATEDISPLAY	(WM_USER + 11)

IMPLEMENT_DYNAMIC(CSensorDlg, CDialogEx)

CSensorDlg::CSensorDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSensorDlg::IDD, pParent)
{

}

CSensorDlg::~CSensorDlg()
{
}

void CSensorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	 DDX_Control(pDX, IDC_SENSOR_OUTPUT_BOX, m_wndOutput);
}


BEGIN_MESSAGE_MAP(CSensorDlg, CDialogEx)
	ON_WM_CREATE()
	ON_MESSAGE(WM_UPDATEDISPLAY, &CSensorDlg::OnUpdateDisplay)
	ON_BN_CLICKED(IDCANCEL, &CSensorDlg::OnBnClickedCancel)
END_MESSAGE_MAP()



// CSensorDlg Ϣ

int CSensorDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialogEx::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!CreateTrackThread())
	{
		AfxMessageBox(_T("Fail to Create Thread!"), MB_OK | MB_ICONERROR);
		return -1;
	}

	return 0;
}


BOOL CSensorDlg::CreateTrackThread()
{
	m_hContinueEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (m_hContinueEvent == NULL)
		return FALSE;

	m_hExitEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (m_hExitEvent == NULL)
	{
		CloseHandle(m_hContinueEvent);
		return FALSE;
	}

	

	m_hTrackThread = CreateThread(NULL, 0, StatusTrack, this, 0, NULL);
	if (m_hTrackThread == NULL)
	{
		CloseHandle(m_hContinueEvent);
		CloseHandle(m_hExitEvent);
		return FALSE;
	}
	return TRUE;
}

DWORD CSensorDlg::StatusTrack(LPVOID pvParam)
{
	CSensorDlg *pDlg = (CSensorDlg*)pvParam;
	BOOL bWaitUpdate = FALSE;
	long ret;
	while (TRUE)
	{
		if (WaitForSingleObject(pDlg->m_hExitEvent, 500) == WAIT_OBJECT_0)
			break;

		if (bWaitUpdate)
		{
			if (WaitForSingleObject(pDlg->m_hContinueEvent, 100) != WAIT_OBJECT_0)
				continue;

			bWaitUpdate = FALSE;
		}
		pDlg->dwRevLength = 256;
		ret = F3_Exec(g_hReader,0x31,0x31, NULL,0, pDlg->szRevBuff, &pDlg->dwRevLength);

		while (!pDlg->PostMessage(WM_UPDATEDISPLAY, ret))
			;
		bWaitUpdate = TRUE;
	}

	return 0;
}


LRESULT CSensorDlg::OnUpdateDisplay(WPARAM wParam, LPARAM lParam)
{
    BYTE b;
    CString strText;
    long ret = (long)wParam;
	m_wndOutput.SetWindowText(NULL);
	if ( szRevBuff[0] == '1')
		m_wndOutput.Output(_T("SEN1 Position:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN1 Position:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[1] == '1')
		m_wndOutput.Output(_T("SEN2 Position:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN2 Position:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[2] == '1')
		m_wndOutput.Output(_T("SEN3 Position:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN3 Position:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[3] == '1')
		m_wndOutput.Output(_T("SEN4 Position:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN4 Position:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[4] == '1')
		m_wndOutput.Output(_T("SEN5 Card Hook Start Position:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN5 Card Hook Start Position:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[5] == '1')
		m_wndOutput.Output(_T("SEN6 Card Hook End Position(ڷ):\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN6 Card Hook End Position:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[6] == '1')
		m_wndOutput.Output(_T("SEN7λռ:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN7 Card Tray Top Sensor:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[7] == '1')
		m_wndOutput.Output(_T("SEN8 Card Sufficiency Sensor:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN8 Card Sufficiency Sensor:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[8] == '1')
		m_wndOutput.Output(_T("SEN9 Card Empty Sensor:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN9 Card Empty Sensor:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[9] == '1')
		m_wndOutput.Output(_T("SEN10 Card Tray Bottom Sensor:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("SEN10 Card Tray Bottom Sensor:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[10] == '1')
		m_wndOutput.Output(_T("Y Tray Card Box Sensor:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("Y Tray Card Box Sensor:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[11] == '1')
		m_wndOutput.Output(_T("N Tray Card Box Sensor:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("N Tray:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[12] == '1')
		m_wndOutput.Output(_T("Y Card Box Full Sensor:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("Y Card Box Full Sensor:\tNo Card\r\n\r\n"), CLR_ERROR);

	if ( szRevBuff[13] == '1')
		m_wndOutput.Output(_T("N Card Box Full Sensor:\tCard In\r\n\r\n"));
	else
		m_wndOutput.Output(_T("N Card Box Full Sensor:\tNo Card\r\n\r\n"), CLR_ERROR);


    SetEvent(m_hContinueEvent);
    return 0;
}

void CSensorDlg::OnBnClickedCancel()
{
	// TODO: ڴӿؼ֪ͨ
	ExitTrackThread();
	DestroyWindow();
	//CDialogEx::OnCancel();
}


void CSensorDlg::ExitTrackThread()
{
	SetEvent(m_hExitEvent);
	if (WaitForSingleObject(m_hTrackThread, 5000) != WAIT_OBJECT_0)
		TerminateThread(m_hTrackThread, 0);

	CloseHandle(m_hContinueEvent);
	CloseHandle(m_hExitEvent);
}