// Sle4428Panel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "Sle4428Panel.h"


// CSle4428Panel Ի

IMPLEMENT_DYNAMIC(CSle4428Panel, CPanelBase)

CSle4428Panel::CSle4428Panel(CWnd* pParent /*=NULL*/)
	: CPanelBase(CSle4428Panel::IDD, pParent)
{

}

CSle4428Panel::~CSle4428Panel()
{
}

void CSle4428Panel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLE4428_MM_GRID, m_MmGrid);
	DDX_Control(pDX, IDC_SLE4428_ADDRESS_BOX, m_AddrBox);
	DDX_Control(pDX, IDC_SLE4428_BYTES_BOX, m_BytesBox);

	DDX_Control(pDX, IDC_SLE4428_PSC_GRID, m_PscGrid);
}


BEGIN_MESSAGE_MAP(CSle4428Panel, CPanelBase)
	ON_BN_CLICKED(IDC_SLE4428_ACTIVATE, &CSle4428Panel::OnBnClickedSle4428Activate)
	ON_BN_CLICKED(IDC_SLE4428_DEACTIVATE, &CSle4428Panel::OnBnClickedSle4428Deactivate)
	ON_BN_CLICKED(IDC_SLE4428_STATUS, &CSle4428Panel::OnBnClickedSle4428Status)
	ON_BN_CLICKED(IDC_SLE4428_READ_8_BITS, &CSle4428Panel::OnBnClickedSle4428Read8Bits)
	ON_BN_CLICKED(IDC_SLE4428_WRITE_WITHOUT_PB, &CSle4428Panel::OnBnClickedSle4428WriteWithoutPb)
	ON_BN_CLICKED(IDC_SLE4428_WRITE_WITH_DATA_COMPARISON, &CSle4428Panel::OnBnClickedSle4428WriteWithDataComparison)
	ON_BN_CLICKED(IDC_SLE4428_WRITE_WITH_PB, &CSle4428Panel::OnBnClickedSle4428WriteWithPb)
	ON_BN_CLICKED(IDC_SLE4428_READ_PROTECTION_BITS, &CSle4428Panel::OnBnClickedSle4428ReadProtectionBits)
	ON_BN_CLICKED(IDC_SLE4428_VERIFY_PSC, &CSle4428Panel::OnBnClickedSle4428VerifyPsc)
	ON_WM_ENABLE()
END_MESSAGE_MAP()


// CSle4428Panel Ϣ


BOOL CSle4428Panel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	m_MmGrid.Init(9, 17, 1, 1);
	m_MmGrid.InitRowHeader();
	m_MmGrid.InitColumnHeader();

	BYTE PSCBytes[] = { 0XFF, 0XFF };
	m_PscGrid.Init(1, 2, 0, 0);
	m_PscGrid.Fill(PSCBytes, sizeof(PSCBytes));

	m_AddrBox.AllowHexInput();
	m_AddrBox.SetLimitText(3);
	m_AddrBox.SetRange(0, 0x3ff);
	m_AddrBox.SetValue(0);

	m_BytesBox.SetValue(128);
	//m_BytesBox.EnableWindow(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CSle4428Panel::OnBnClickedSle4428Activate()
{
	BYTE ATRBuff[32];
	DWORD ATRLength = sizeof(ATRBuff);

	LONG lResult = F3_Sle4428Activate(g_hReader, ATRBuff, &ATRLength);

	CString strMsg;
	if (lResult == 0)
	{
		CString strATR;
		Bytes2HexString(ATRBuff, ATRLength, strATR);
		strMsg.Format(_T("ATR: %s"), strATR);
	}

	OutputResult(lResult, GetFocus(), strMsg);
}


void CSle4428Panel::OnBnClickedSle4428Deactivate()
{
	LONG lResult = F3_Sle4428Deactivate(g_hReader);
	OutputResult(lResult, GetFocus(), NULL);
}


void CSle4428Panel::OnBnClickedSle4428Status()
{
	BOOL bActivated;

	LONG lResult = F3_Sle4428GetStatus(g_hReader, &bActivated);

	CString strMsg;
	if (lResult == 0)
	{
		CString s1;
		LoadString( bActivated ? IDS_ACTIVATED : IDS_UNACTIVATED, s1);

		strMsg.Format(_T("SLE4428 %s"), s1);
	}

	OutputResult(lResult, GetFocus(), strMsg);
}


void CSle4428Panel::OnBnClickedSle4428Read8Bits()
{
	Read(RT_MAIN_MEMORY);
}


void CSle4428Panel::OnBnClickedSle4428WriteWithoutPb()
{
	Write(WT_WITHOUT_PB);
}


void CSle4428Panel::OnBnClickedSle4428WriteWithDataComparison()
{
	Write(WT_WITH_DATA_COMPARISON);
}


void CSle4428Panel::OnBnClickedSle4428WriteWithPb()
{
	Write(WT_WITH_PB);
}


void CSle4428Panel::OnBnClickedSle4428ReadProtectionBits()
{
	Read(RT_PROTECTION_BITS);
}


void CSle4428Panel::OnBnClickedSle4428VerifyPsc()
{
	if (! m_PscGrid.ValidateInput())
		return;

	BYTE bBuffer[2];
	m_PscGrid.GetContent(bBuffer, sizeof(bBuffer));

	LONG lResult = F3_Sle4428VerifyPSC(g_hReader, bBuffer);
	OutputResult(lResult, GetFocus(), NULL);
}


void CSle4428Panel::Read(READTYPE iType)
{
	if (! m_AddrBox.IsValidInput())
		return;
	if (! m_BytesBox.IsValidInput())
		return;

	WORD wAddr = (WORD) m_AddrBox.GetValue();
	BYTE nBytesToRead = (BYTE) m_BytesBox.GetValue();

	BYTE bBuffer[256];
	DWORD Length = sizeof(bBuffer);

	LONG lResult;
	if (iType == RT_MAIN_MEMORY)
	{
		lResult = F3_Sle4428ReadMainMemory(g_hReader, wAddr, nBytesToRead, bBuffer, &Length);
	}
	else
	{
		lResult = F3_Sle4428ReadProtectionBits(g_hReader, (BYTE) wAddr, nBytesToRead, bBuffer, &Length);
	}

	OutputResult(lResult, GetFocus(), NULL);

	m_MmGrid.ResetContent();

	if (lResult == 0)
		m_MmGrid.Fill(bBuffer, Length);
}


void CSle4428Panel::Write(WRITETYPE iType)
{
	if (! m_AddrBox.IsValidInput())
		return;
	if (! m_BytesBox.IsValidInput())
		return;
	if (! m_MmGrid.ValidateInput())
		return;

	WORD wAddr = (WORD) m_AddrBox.GetValue();

	BYTE bBuffer[256];
	BYTE nBytesToWrite = (BYTE) m_MmGrid.GetContent(bBuffer, m_BytesBox.GetValue());

	LONG lResult;
	if (iType == WT_WITHOUT_PB)
		lResult = F3_Sle4428WriteWithoutPB(g_hReader, wAddr, nBytesToWrite, bBuffer);
	else if (iType == WT_WITH_DATA_COMPARISON)
		lResult =  F3_Sle4428WriteWithDataComparison(g_hReader, wAddr, nBytesToWrite, bBuffer);
	else
		lResult =  F3_Sle4428WriteWithPB(g_hReader, wAddr, nBytesToWrite, bBuffer);

	OutputResult(lResult, GetFocus(), NULL);

	if (lResult == 0)
		m_MmGrid.ResetContent();
}


void CSle4428Panel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	GetDlgItem(IDC_SLE4428_ACTIVATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4428_DEACTIVATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4428_STATUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4428_READ_8_BITS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4428_WRITE_WITHOUT_PB)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4428_WRITE_WITH_DATA_COMPARISON)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4428_WRITE_WITH_PB)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4428_READ_PROTECTION_BITS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4428_VERIFY_PSC)->EnableWindow(bEnable);

	m_AddrBox.EnableWindow(bEnable);
	m_BytesBox.EnableWindow(bEnable);
}
