// Sle4442Panel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "Sle4442Panel.h"


// CSle4442Panel Ի

IMPLEMENT_DYNAMIC(CSle4442Panel, CPanelBase)

CSle4442Panel::CSle4442Panel(CWnd* pParent /*=NULL*/)
	: CPanelBase(CSle4442Panel::IDD, pParent)
{

}

CSle4442Panel::~CSle4442Panel()
{
}

void CSle4442Panel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLE4442_MM_GRID, m_MmGrid);
	DDX_Control(pDX, IDC_SLE4442_ADDRESS_BOX, m_AddrBox);
	DDX_Control(pDX, IDC_SLE4442_BYTES_BOX, m_BytesBox);

	DDX_Control(pDX, IDC_SLE4442_PSC_GRID, m_PscGrid);
	DDX_Control(pDX, IDC_SLE4442_EC_BOX, m_ECBox);
}


BEGIN_MESSAGE_MAP(CSle4442Panel, CPanelBase)
	ON_BN_CLICKED(IDC_SLE4442_ACTIVATE, &CSle4442Panel::OnBnClickedSle4442Activate)
	ON_BN_CLICKED(IDC_SLE4442_DEACTIVATE, &CSle4442Panel::OnBnClickedSle4442Deactivate)
	ON_BN_CLICKED(IDC_SLE4442_STATUS, &CSle4442Panel::OnBnClickedSle4442Status)
	ON_BN_CLICKED(IDC_SLE4442_READ_MAIN_MEMORY, &CSle4442Panel::OnBnClickedSle4442ReadMainMemory)
	ON_BN_CLICKED(IDC_SLE4442_UPDATE_MAIN_MEMORY, &CSle4442Panel::OnBnClickedSle4442UpdateMainMemory)
	ON_BN_CLICKED(IDC_SLE4442_READ_PROTECTION_MEMORY, &CSle4442Panel::OnBnClickedSle4442ReadProtectionMemory)
	ON_BN_CLICKED(IDC_SLE4442_WRITE_PROTECTION_MEMORY, &CSle4442Panel::OnBnClickedSle4442WriteProtectionMemory)
	ON_BN_CLICKED(IDC_SLE4442_READ_SECURITY_MEMORY, &CSle4442Panel::OnBnClickedSle4442ReadSecurityMemory)
	ON_BN_CLICKED(IDC_SLE4442_WRITE_ERROR_COUNTER, &CSle4442Panel::OnBnClickedSle4442WriteErrorCounter)
	ON_BN_CLICKED(IDC_SLE4442_VERIFY_PSC, &CSle4442Panel::OnBnClickedSle4442VerifyPsc)
	ON_BN_CLICKED(IDC_SLE4442_UPDATE_PSC, &CSle4442Panel::OnBnClickedSle4442UpdatePsc)
	ON_WM_ENABLE()
END_MESSAGE_MAP()


// CSle4442Panel Ϣ


BOOL CSle4442Panel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	m_MmGrid.Init(9, 17, 1, 1);
	m_MmGrid.InitRowHeader();
	m_MmGrid.InitColumnHeader();


	BYTE PSCBytes[] = { 0XFF, 0XFF, 0xff };
	m_PscGrid.Init(1, 3, 0, 0);
	m_PscGrid.Fill(PSCBytes, sizeof(PSCBytes));


	m_AddrBox.AllowHexInput();
	m_AddrBox.SetLimitText(2);
	m_AddrBox.SetRange(0, 0xff);
	m_AddrBox.SetValue(0);

	m_BytesBox.SetValue(128);
	//m_BytesBox.EnableWindow(FALSE);

	m_ECBox.SetRange(0, 8);
	m_ECBox.SetLimitText(1);
	m_ECBox.SetValue(7);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CSle4442Panel::OnBnClickedSle4442Activate()
{
	BYTE ATRBuff[32];
	DWORD ATRLength = sizeof(ATRBuff);

	LONG lResult = F3_Sle4442Activate(g_hReader, ATRBuff, &ATRLength);

	CString strMsg;
	if (lResult == 0)
	{
		CString strATR;
		Bytes2HexString(ATRBuff, ATRLength, strATR);
		strMsg.Format(_T("ATR: %s"), strATR);
	}

	OutputResult(lResult, GetFocus(), strMsg);

}


void CSle4442Panel::OnBnClickedSle4442Deactivate()
{
	LONG lResult = F3_Sle4442Deactivate(g_hReader);
	OutputResult(lResult, GetFocus(), NULL);
}


void CSle4442Panel::OnBnClickedSle4442Status()
{
	BOOL bActivated;

	LONG lResult = F3_Sle4442GetStatus(g_hReader, &bActivated);

	CString strMsg;
	if (lResult == 0)
	{
		CString s1;
		LoadString( bActivated ? IDS_ACTIVATED : IDS_UNACTIVATED, s1);

		strMsg.Format(_T("SLE4442 %s"), s1);
	}

	OutputResult(lResult, GetFocus(), strMsg);
}


void CSle4442Panel::OnBnClickedSle4442ReadMainMemory()
{
	if (! m_AddrBox.IsValidInput())
		return;
	if (! m_BytesBox.IsValidInput())
		return;

	BYTE iAddr = (BYTE) m_AddrBox.GetValue();
	BYTE nBytesToRead = (BYTE) m_BytesBox.GetValue();

	BYTE bBuffer[256];
	DWORD Length = sizeof(bBuffer);

	LONG lResult = F3_Sle4442ReadMainMemory(g_hReader, iAddr, nBytesToRead, bBuffer, &Length);

	OutputResult(lResult, GetFocus(), NULL);

	m_MmGrid.ResetContent();

	if (lResult == 0)
		m_MmGrid.Fill(bBuffer, Length);
}


void CSle4442Panel::OnBnClickedSle4442UpdateMainMemory()
{
	if (! m_AddrBox.IsValidInput())
		return;
	if (! m_BytesBox.IsValidInput())
		return;
	if (! m_MmGrid.ValidateInput())
		return;

	BYTE iAddr = (BYTE) m_AddrBox.GetValue();

	BYTE bBuffer[256];
	BYTE nBytesToWrite = (BYTE) m_MmGrid.GetContent(bBuffer, m_BytesBox.GetValue());

	LONG lResult = F3_Sle4442UpdateMainMemory(g_hReader, iAddr, nBytesToWrite, bBuffer);
	OutputResult(lResult, GetFocus(), NULL);

	if (lResult == 0)
		m_MmGrid.ResetContent();
}


void CSle4442Panel::OnBnClickedSle4442ReadProtectionMemory()
{
	BYTE bBuffer[4];
	DWORD Length = sizeof(bBuffer);

	m_BytesBox.SetValue(4);

	BYTE iAddr = (BYTE) m_AddrBox.GetValue();
	BYTE nBytesToRead = (BYTE) m_BytesBox.GetValue();

	LONG lResult= F3_Sle4442ReadProtectionMemory(g_hReader, iAddr, nBytesToRead, bBuffer, &Length);

	OutputResult(lResult, GetFocus(), NULL);

	m_MmGrid.ResetContent();

	if (lResult == 0)
		m_MmGrid.Fill(bBuffer, Length);
}


void CSle4442Panel::OnBnClickedSle4442WriteProtectionMemory()
{
	if (! m_AddrBox.IsValidInput())
		return;
	if (! m_BytesBox.IsValidInput())
		return;
	if (! m_MmGrid.ValidateInput())
		return;

	BYTE iAddr = (BYTE) m_AddrBox.GetValue();

	BYTE bBuffer[256];
	BYTE nBytesToWrite = m_BytesBox.GetValue();


	m_MmGrid.GetContent(bBuffer, nBytesToWrite);

	LONG lResult= F3_Sle4442WriteProtectionMemory(g_hReader, iAddr, (BYTE) nBytesToWrite, bBuffer);


	OutputResult(lResult, GetFocus(), NULL);

	if (lResult == 0)
		m_MmGrid.ResetContent();
}



void CSle4442Panel::OnBnClickedSle4442ReadSecurityMemory()
{
	BYTE bBuffer[4];
	DWORD Length = sizeof(bBuffer);

	m_BytesBox.SetValue(4);

	BYTE iAddr = (BYTE) m_AddrBox.GetValue();
	BYTE nBytesToRead = (BYTE) m_BytesBox.GetValue();

	LONG lResult= F3_Sle4442ReadSecurityMemory(g_hReader, iAddr, nBytesToRead, bBuffer, &Length);

	OutputResult(lResult, GetFocus(), NULL);

	m_MmGrid.ResetContent();

	if (lResult == 0)
		m_MmGrid.Fill(bBuffer, Length);
}


void CSle4442Panel::OnBnClickedSle4442WriteErrorCounter()
{
	if (! m_ECBox.IsValidInput())
		return;

	BYTE iEcVal = (BYTE) m_ECBox.GetValue();

	LONG lResult = F3_Sle4442WriteErrorCounter(g_hReader, iEcVal);
	OutputResult(lResult, GetFocus(), NULL);
}


void CSle4442Panel::OnBnClickedSle4442VerifyPsc()
{
	PscOp(true);
}


void CSle4442Panel::OnBnClickedSle4442UpdatePsc()
{
	PscOp(false);
}

void CSle4442Panel::PscOp(bool bVerify)
{
	if (! m_PscGrid.ValidateInput())
		return;

	BYTE bBuffer[3];
	m_PscGrid.GetContent(bBuffer, sizeof(bBuffer));

	LONG lResult;
	if (bVerify)
		lResult = F3_Sle4442VerifyPSC(g_hReader, bBuffer);
	else
		lResult = F3_Sle4442UpdatePSC(g_hReader, bBuffer);

	OutputResult(lResult, GetFocus(), NULL);
}

void CSle4442Panel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	GetDlgItem(IDC_SLE4442_ACTIVATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_DEACTIVATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_STATUS)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_READ_MAIN_MEMORY)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_UPDATE_MAIN_MEMORY)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_READ_PROTECTION_MEMORY)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_WRITE_PROTECTION_MEMORY)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_READ_SECURITY_MEMORY)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_WRITE_ERROR_COUNTER)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_VERIFY_PSC)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLE4442_UPDATE_PSC)->EnableWindow(bEnable);

	m_AddrBox.EnableWindow(bEnable);
	m_ECBox.EnableWindow(bEnable);
	m_BytesBox.EnableWindow(bEnable);
}
