// UlPanel.cpp : ʵļ
//

#include "stdafx.h"
#include "F3TEST.h"
#include "UlPanel.h"


// CUlPanel Ի

IMPLEMENT_DYNAMIC(CUlPanel, CPanelBase)

CUlPanel::CUlPanel(CWnd* pParent /*=NULL*/)
	: CPanelBase(CUlPanel::IDD, pParent)
{

}

CUlPanel::~CUlPanel()
{
}

void CUlPanel::DoDataExchange(CDataExchange* pDX)
{
	CPanelBase::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_UL_DATA_GRID, m_DataGrid);
}


BEGIN_MESSAGE_MAP(CUlPanel, CPanelBase)
	ON_CBN_SELCHANGE(IDC_UL_SECTOR_NUMBER_LIST, &CUlPanel::OnCbnSelchangeUlSectorNumberList)
	ON_BN_CLICKED(IDC_UL_READ_SECTOR, &CUlPanel::OnBnClickedUlReadSector)
	ON_BN_CLICKED(IDC_UL_WRITE_SECTOR, &CUlPanel::OnBnClickedUlWriteSector)
	ON_WM_ENABLE()
END_MESSAGE_MAP()


// CUlPanel Ϣ


BOOL CUlPanel::OnInitDialog()
{
	CPanelBase::OnInitDialog();

	CComboBox *pList;
	CString str;
	int	idx;

	pList = GetComboBox(IDC_UL_SECTOR_NUMBER_LIST);
	for (int i = 0; i < 16; i++)
	{
		str.Format(_T("%d"), i);
		idx = pList->AddString(str);
		pList->SetItemData(idx, i);
	}
	pList->SetCurSel(0);
	m_iSectorNum = (BYTE) pList->GetItemData(pList->GetCurSel());

	m_DataGrid.Init(1, 4, 0, 0);

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}


void CUlPanel::OnCbnSelchangeUlSectorNumberList()
{
	CComboBox *pList = GetComboBox(IDC_UL_SECTOR_NUMBER_LIST);
	m_iSectorNum = (BYTE) pList->GetItemData(pList->GetCurSel());
}


void CUlPanel::OnBnClickedUlReadSector()
{
	BYTE bBuffer[4];
	DWORD Length = sizeof(bBuffer);
	LONG lResult = F3_MfReadSector(g_hReader, m_iSectorNum, 0,bBuffer, &Length);
	OutputResult(lResult, GetFocus(), NULL);

	m_DataGrid.ResetContent();

	if (lResult == 0)
		m_DataGrid.Fill(bBuffer, Length);
}


void CUlPanel::OnBnClickedUlWriteSector()
{
	if (! m_DataGrid.ValidateInput())
		return;

	BYTE bBuffer[4];
	m_DataGrid.GetContent(bBuffer, sizeof(bBuffer));

	LONG lResult = F3_MfWriteSector(g_hReader, m_iSectorNum, 0, 4, bBuffer);
	OutputResult(lResult, GetFocus(), NULL);

	if (lResult == 0)
		m_DataGrid.ResetContent();
}


void CUlPanel::OnEnable(BOOL bEnable)
{
	CPanelBase::OnEnable(bEnable);

	GetDlgItem(IDC_UL_SECTOR_NUMBER_LIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_UL_READ_SECTOR)->EnableWindow(bEnable);
	GetDlgItem(IDC_UL_WRITE_SECTOR)->EnableWindow(bEnable);
}
