#include "StdAfx.h"
#include "Public.h"



#define ID_RICH_COPY                    103
#define ID_RICH_CLEAR                   105
#define ID_RICH_SELECTALL               106


// UIOutputBox

IMPLEMENT_DYNAMIC(UIOutputBox, CRichEditCtrl)

UIOutputBox::UIOutputBox()
{

}

UIOutputBox::~UIOutputBox()
{
}


BEGIN_MESSAGE_MAP(UIOutputBox, CRichEditCtrl)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_RICH_COPY, OnCopy)
	ON_COMMAND(ID_RICH_SELECTALL, OnSelectall)
	ON_COMMAND(ID_RICH_CLEAR, OnClear)	
END_MESSAGE_MAP()


void UIOutputBox::PreSubclassWindow()
{
	SetBackgroundColor(FALSE, GetSysColor(COLOR_INFOBK));

	CRichEditCtrl::PreSubclassWindow();
}


void UIOutputBox::OnRButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	CMenu popmenu;
	popmenu.CreatePopupMenu();
	popmenu.AppendMenu(0, ID_RICH_COPY, _T("C&opy"));
	popmenu.AppendMenu(0, ID_RICH_CLEAR, _T("C&lear"));
	popmenu.AppendMenu(0, MF_SEPARATOR);
	popmenu.AppendMenu(0, ID_RICH_SELECTALL, _T("Select &All"));

	UINT nSel=((GetSelectionType()!=SEL_EMPTY) ? 0 : MF_GRAYED) ;
	popmenu.EnableMenuItem(ID_RICH_COPY, MF_BYCOMMAND|nSel);
	popmenu.EnableMenuItem(ID_RICH_CLEAR, MF_BYCOMMAND);

	CPoint pt;
	GetCursorPos(&pt);
	popmenu.TrackPopupMenu(TPM_RIGHTBUTTON, pt.x, pt.y, this);
	popmenu.DestroyMenu();
}


void UIOutputBox::OnCopy() 
{ 
	Copy(); 
}


void UIOutputBox::OnSelectall() 
{ 
	SetSel(0, -1); 
}


void UIOutputBox::OnClear() 
{ 
	SetWindowText(NULL); 
}


BOOL UIOutputBox::Create(CWnd *pParentWnd, CRect &rect, UINT nID)
{
    DWORD dwStyle = WS_VISIBLE | WS_CHILD;
    return CRichEditCtrl::Create(dwStyle, rect, pParentWnd, nID);
}


void UIOutputBox::Output(LPCTSTR lpszText, COLORREF clrText)
{
	CHARFORMAT cFmt; 
	cFmt.cbSize = sizeof(CHARFORMAT);  
	cFmt.dwMask = CFM_COLOR | CFM_BOLD | CFM_SIZE;
	cFmt.dwEffects = CFE_BOLD;
	cFmt.crTextColor = clrText;
	cFmt.yHeight = 14 * 1440 / 96;

	SetSel(-1, -1);
	SetSelectionCharFormat(cFmt);
	ReplaceSel(lpszText);
	PostMessage(WM_VSCROLL, SB_BOTTOM,0); 
	//SetFocus();
}