#pragma once


#include <MsXml.h>

// Macro that calls a COM method returning HRESULT value.
#define CHK_HR(stmt)        do { hr=(stmt); if (FAILED(hr)) goto CleanUp; } while(0)

// Macro to verify memory allcation.
#define CHK_ALLOC(p)        do { if (!(p)) { hr = E_OUTOFMEMORY; goto CleanUp; } } while(0)

// Macro that releases a COM object if not NULL.
#define SAFE_RELEASE(p)     do { if ((p)) { (p)->Release(); (p) = NULL; } } while(0)

HRESULT VariantFromString(PCWSTR wszValue, VARIANT &Variant);
HRESULT CreateAndInitDOM(IXMLDOMDocument **ppDoc);
HRESULT CreateElement(IXMLDOMDocument *pXMLDom, PCWSTR wszName, IXMLDOMElement **ppElement);
HRESULT AppendChildToParent(IXMLDOMNode *pChild, IXMLDOMNode *pParent);
HRESULT CreateAndAddPINode(IXMLDOMDocument *pDoc, PCWSTR wszTarget, PCWSTR wszData);
HRESULT CreateAndAddCommentNode(IXMLDOMDocument *pDoc, PCWSTR wszComment);
HRESULT CreateAndAddAttributeNode(IXMLDOMDocument *pDoc, PCWSTR wszName, PCWSTR wszValue, IXMLDOMElement *pParent);
HRESULT CreateAndAddTextNode(IXMLDOMDocument *pDoc, PCWSTR wszText, IXMLDOMNode *pParent);
HRESULT CreateAndAddCDATANode(IXMLDOMDocument *pDoc, PCWSTR wszCDATA, IXMLDOMNode *pParent);
HRESULT CreateAndAddElementNode(IXMLDOMDocument *pDoc, PCWSTR wszName, PCWSTR wszNewline, IXMLDOMNode *pParent, IXMLDOMElement **ppElement);
HRESULT SelectSingleNode(IXMLDOMDocument *pDoc, PCWSTR pszExpr, IXMLDOMNode **ppResultNode);
HRESULT SelectNodes(IXMLDOMDocument *pDoc, PCWSTR pszExpr, IXMLDOMNodeList **ppResultList);
HRESULT SelectNodes2(IXMLDOMNode *pNode, PCWSTR pszExpr, IXMLDOMNodeList **ppResultList);