#pragma once

#include "MSFlexGrid.h"
#include "InPlaceEdit.h"

class AFX_EXT_CLASS CMSFlexGridExt
	: public CMSFlexGrid
{
	friend class CInPlaceEdit;

	DECLARE_DYNAMIC(CMSFlexGridExt)
public:
	CMSFlexGridExt();
	virtual ~CMSFlexGridExt();

	void	SetReadOnly(bool bReadOnly) { m_bReadOnly = bReadOnly; }
	bool	IsReadOnly() { return m_bReadOnly; }

	void	SetEditableCells(long lEditableCells);
	long	GetEditableCells() { return m_lEditableCells; }

	BOOL	UpdateData(BOOL bSaveAndValidate = TRUE);
	void	ResetContent();

	void	SelectCurrCell();

	// Helper
	void	Init(long lTotalRows, long lTotalCols, long lFixedRows, long lFixedCols, long lCellWidth = 320);
	void	InitRowHeader(long lStartVal = 0);
	void	InitColumnHeader(long lStartVal = 0);
	bool	ValidateInput();
	void	Fill(PBYTE pbBuffer, DWORD dwLength, bool bAdjustCells = false);
	DWORD	GetContent(PBYTE pbBuffer, DWORD cchBufferMax);


protected:
	virtual void PreSubclassWindow();
	void	EditCell(short KeyAscii);
	void	EndEdit();
	void	SelectNextCell();

	CInPlaceEdit m_EditWnd;
	long	m_lBorderWidth;
	long	m_lBorderHeight;
	int	m_nLogX;
	int	m_nLogY;
	bool	m_bReadOnly;
	long	m_lEditableCells;

protected:
	DECLARE_EVENTSINK_MAP()
	afx_msg void OnKeyPress(short FAR* KeyAscii);
	afx_msg void OnLeaveCell();
	afx_msg void OnEnterCell();

protected:
	DECLARE_MESSAGE_MAP()
	afx_msg UINT OnGetDlgCode();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
};